// CiSetup.cpp : implementation file
//

#include "stdafx.h"
#include "dib.h"
#include "CiSetup.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CMainFrame* mainFrame;

/////////////////////////////////////////////////////////////////////////////
// CCiCropCirclePage property page

IMPLEMENT_DYNCREATE(CCiCropCirclePage, CPropertyPage)

CCiCropCirclePage::CCiCropCirclePage() : CPropertyPage(CCiCropCirclePage::IDD)
{
	//{{AFX_DATA_INIT(CCiCropCirclePage)
	radius = 0;
	x = 0;
	y = 0;
	blankout_start = 0;
	blankout_end = 0;
	//}}AFX_DATA_INIT
}

CCiCropCirclePage::~CCiCropCirclePage()
{
}

void CCiCropCirclePage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCiCropCirclePage)
	DDX_Text(pDX, IDC_CROP_RADIUS, radius);
	DDV_MinMaxInt(pDX, radius, 0, 1000);
	DDX_Text(pDX, IDC_CROP_X, x);
	DDV_MinMaxInt(pDX, x, 0, 1000);
	DDX_Text(pDX, IDC_CROP_Y, y);
	DDV_MinMaxInt(pDX, y, 0, 1000);
	DDX_Text(pDX, IDC_BLANKOUT_START, blankout_start);
	DDV_MinMaxInt(pDX, blankout_start, 0, 359);
	DDX_Text(pDX, IDC_BLANKOUT_END, blankout_end);
	DDV_MinMaxInt(pDX, blankout_end, 0, 359);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCiCropCirclePage, CPropertyPage)
	//{{AFX_MSG_MAP(CCiCropCirclePage)
	ON_WM_CANCELMODE()
	ON_EN_CHANGE(IDC_CROP_RADIUS, OnChangeCropRadius)
	ON_EN_CHANGE(IDC_CROP_X, OnChangeCropX)
	ON_EN_CHANGE(IDC_CROP_Y, OnChangeCropY)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCiCropCirclePage message handlers

BOOL CCiCropCirclePage::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	return CPropertyPage::OnCommand(wParam, lParam);
}


/////////////////////////////////////////////////////////////////////////////
// CCiSetupOutputPage property page

IMPLEMENT_DYNCREATE(CCiSetupOutputPage, CPropertyPage)

CCiSetupOutputPage::CCiSetupOutputPage() : CPropertyPage(CCiSetupOutputPage::IDD)
{
	//{{AFX_DATA_INIT(CCiSetupOutputPage)
	m_output_k = FALSE;
	m_output_LAI = FALSE;
	m_output_LD = FALSE;
	m_output_MFIA = FALSE;
	m_output_TD = FALSE;
	m_output_TR = FALSE;
	m_output_PAR = FALSE;
	m_output_SUNTRACK = FALSE;
	//}}AFX_DATA_INIT
}

CCiSetupOutputPage::~CCiSetupOutputPage()
{
}

void CCiSetupOutputPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCiSetupOutputPage)
	DDX_Check(pDX, IDC_SETUP_OUTPUT_K, m_output_k);
	DDX_Check(pDX, IDC_SETUP_OUTPUT_LAI, m_output_LAI);
	DDX_Check(pDX, IDC_SETUP_OUTPUT_LD, m_output_LD);
	DDX_Check(pDX, IDC_SETUP_OUTPUT_MFIA, m_output_MFIA);
	DDX_Check(pDX, IDC_SETUP_OUTPUT_TD, m_output_TD);
	DDX_Check(pDX, IDC_SETUP_OUTPUT_TR, m_output_TR);
	DDX_Check(pDX, IDC_SETUP_OUTPUT_PAR, m_output_PAR);
	DDX_Check(pDX, IDC_SETUP_OUTPUT_LATITUDE, m_output_SUNTRACK);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCiSetupOutputPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCiSetupOutputPage)
	ON_BN_CLICKED(IDC_SETUP_OUTPUT_K, OnSetupOutputK)
	ON_BN_CLICKED(IDC_SETUP_OUTPUT_LAI, OnSetupOutputLai)
	ON_BN_CLICKED(IDC_SETUP_OUTPUT_LD, OnSetupOutputLd)
	ON_BN_CLICKED(IDC_SETUP_OUTPUT_MFIA, OnSetupOutputMfia)
	ON_BN_CLICKED(IDC_SETUP_OUTPUT_TD, OnSetupOutputTd)
	ON_BN_CLICKED(IDC_SETUP_OUTPUT_TR, OnSetupOutputTr)
	ON_BN_CLICKED(IDC_SETUP_OUTPUT_PAR, OnSetupOutputPAR)
	ON_BN_CLICKED(IDC_SETUP_OUTPUT_LATITUDE, OnSetupOutputLATITUDE)
	ON_BN_DOUBLECLICKED(IDC_SETUP_OUTPUT_K, OnDoubleclickedSetupOutputK)
	ON_BN_DOUBLECLICKED(IDC_SETUP_OUTPUT_LAI, OnDoubleclickedSetupOutputLai)
	ON_BN_DOUBLECLICKED(IDC_SETUP_OUTPUT_LD, OnDoubleclickedSetupOutputLd)
	ON_BN_DOUBLECLICKED(IDC_SETUP_OUTPUT_MFIA, OnDoubleclickedSetupOutputMfia)
	ON_BN_DOUBLECLICKED(IDC_SETUP_OUTPUT_TD, OnDoubleclickedSetupOutputTd)
	ON_BN_DOUBLECLICKED(IDC_SETUP_OUTPUT_TR, OnDoubleclickedSetupOutputTr)
	ON_BN_DOUBLECLICKED(IDC_SETUP_OUTPUT_PAR, OnDoubleclickedSetupOutputPAR)
	ON_BN_DOUBLECLICKED(IDC_SETUP_OUTPUT_LATITUDE, OnDoubleclickedSetupOutputLATITUDE)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCiSetupOutputPage message handlers

BOOL CCiSetupOutputPage::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	return CPropertyPage::OnCommand(wParam, lParam);
}


/////////////////////////////////////////////////////////////////////////////
// CCiSetupGeometryPage property page

IMPLEMENT_DYNCREATE(CCiSetupGeometryPage, CPropertyPage)

CCiSetupGeometryPage::CCiSetupGeometryPage() : CPropertyPage(CCiSetupGeometryPage::IDD)
{
	//{{AFX_DATA_INIT(CCiSetupGeometryPage)
	m_AzmuthalDivision = 0;
	m_endZenithAngle = 0;
	m_startZenithAngle = 0;
	m_threshHoldLevel = 0;
	m_PARzerocal = 0.0;
	m_PARspancal = 0.0;
	m_Fleckszerocal = 0.0;
	m_Flecksspancal = 0.0;
	m_viewRange = 0;
	m_zenithDivision = 0;
	m_Latitude = 0;
	m_month1=3;
	m_day1=21;
	m_month2=9;
	m_day2=21;
	//}}AFX_DATA_INIT
}

CCiSetupGeometryPage::~CCiSetupGeometryPage()
{
}

void CCiSetupGeometryPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCiSetupGeometryPage)
	DDX_Text(pDX, IDC_SETUP_GEO_AZM_DIV, m_AzmuthalDivision);
	DDV_MinMaxInt(pDX, m_AzmuthalDivision, 0, 10);
	DDX_Text(pDX, IDC_SETUP_GEO_VIEW_RANGE, m_viewRange);
	DDV_MinMaxInt(pDX, m_viewRange, 150, 180);
	DDX_Text(pDX, IDC_SETUP_GEO_START_ZEN_ANGLE, m_startZenithAngle);
	DDV_MinMaxInt(pDX, m_startZenithAngle, 0, m_viewRange/2);
	DDX_Text(pDX, IDC_SETUP_GEO_END_ZEN_ANGLE, m_endZenithAngle);
	DDV_MinMaxInt(pDX, m_endZenithAngle, m_startZenithAngle, m_viewRange/2);
	DDX_Text(pDX, IDC_SETUP_GEO_THRESH_LEVEL, m_threshHoldLevel);
	DDV_MinMaxInt(pDX, m_threshHoldLevel, 0, 100);
	DDX_Text(pDX, IDC_SETUP_GEO_PARCAL, m_PARzerocal);
	DDV_MinMaxDouble(pDX, m_PARzerocal, -2999.9, 199.9);
	DDX_Text(pDX, IDC_SETUP_GEO_PARCAL2, m_PARspancal);
	DDV_MinMaxDouble(pDX, m_PARspancal, 0.01, 100.0);
	DDX_Text(pDX, IDC_SETUP_GEO_FlecksCAL1, m_Fleckszerocal);
	DDV_MinMaxDouble(pDX, m_Fleckszerocal, -2999.9, 199.9);
	DDX_Text(pDX, IDC_SETUP_GEO_FlecksCAL2, m_Flecksspancal);
	DDV_MinMaxDouble(pDX, m_Flecksspancal, 0.01, 100.0);
	DDX_Text(pDX, IDC_SETUP_GEO_LATITUDE, m_Latitude);
	DDV_MinMaxDouble(pDX, m_Latitude, -90.0, 90.0);
	DDX_Text(pDX, IDC_SETUP_GEO_MONTH1, m_month1);
	DDV_MinMaxInt(pDX, m_month1, 1, 12);
	DDX_Text(pDX, IDC_SETUP_GEO_DAY1, m_day1);
	DDV_MinMaxInt(pDX, m_day1, 1, 31);
	DDX_Text(pDX, IDC_SETUP_GEO_MONTH2, m_month2);
	DDV_MinMaxInt(pDX, m_month2, 1, 12);
	DDX_Text(pDX, IDC_SETUP_GEO_DAY2, m_day2);
	DDV_MinMaxInt(pDX, m_day2, 1, 31);

	DDX_Text(pDX, IDC_SETUP_GEO_ZEN_DIV, m_zenithDivision);
	DDV_MinMaxInt(pDX, m_zenithDivision, 1, 10);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCiSetupGeometryPage, CPropertyPage)
	//{{AFX_MSG_MAP(CCiSetupGeometryPage)
	ON_CBN_SELCHANGE(IDC_SETUP_GEO_VIEW_RANGE, OnSelchangeSetupGeoViewRange)
	ON_EN_CHANGE(IDC_SETUP_GEO_AZM_DIV, OnChangeSetupGeoAzmDiv)
	ON_EN_CHANGE(IDC_SETUP_GEO_END_ZEN_ANGLE, OnChangeSetupGeoEndZenAngle)
	ON_EN_CHANGE(IDC_SETUP_GEO_START_ZEN_ANGLE, OnChangeSetupGeoStartZenAngle)
	ON_EN_CHANGE(IDC_SETUP_GEO_THRESH_LEVEL, OnChangeSetupGeoThreshLevel)
	ON_EN_CHANGE(IDC_SETUP_GEO_PARCAL, OnChangeSetupGeoPARcal)
	ON_EN_CHANGE(IDC_SETUP_GEO_PARCAL2, OnChangeSetupGeoPARcal2)
	ON_EN_CHANGE(IDC_SETUP_GEO_FlecksCAL1, OnChangeSetupGeoFleckscal1)
	ON_EN_CHANGE(IDC_SETUP_GEO_FlecksCAL2, OnChangeSetupGeoFleckscal2)
	ON_EN_CHANGE(IDC_SETUP_GEO_LATITUDE, OnChangeSetupGeoLatitude)
	ON_EN_CHANGE(IDC_SETUP_GEO_MONTH1, OnChangeSetupGeoMonth1)
	ON_EN_CHANGE(IDC_SETUP_GEO_DAY1, OnChangeSetupGeoDay1)
	ON_EN_CHANGE(IDC_SETUP_GEO_MONTH2, OnChangeSetupGeoMonth2)
	ON_EN_CHANGE(IDC_SETUP_GEO_DAY2, OnChangeSetupGeoDay2)
	ON_EN_CHANGE(IDC_SETUP_GEO_ZEN_DIV, OnChangeSetupGeoZenDiv)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCiSetupGeometryPage message handlers

BOOL CCiSetupGeometryPage::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	return CPropertyPage::OnCommand(wParam, lParam);
}

/////////////////////////////////////////////////////////////////////////////
// CCiSetup

IMPLEMENT_DYNAMIC(CCiSetup, CPropertySheet)

CCiSetup::CCiSetup(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
}

CCiSetup::CCiSetup(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddPage(&geometryPage);
	AddPage(&outputPage);
	AddPage(&cropCirclePage);
}

CCiSetup::~CCiSetup()
{
}


BEGIN_MESSAGE_MAP(CCiSetup, CPropertySheet)
	//{{AFX_MSG_MAP(CCiSetup)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCiSetup message handlers

BOOL CCiSetupGeometryPage::OnApply() 
{
	// TODO: Add your specialized code here and/or call the base class
	mainFrame->SendMessage(WM_USERAPPLY);
    return TRUE;
}

BOOL CCiSetup::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CPropertySheet::DestroyWindow();
}

void CCiSetup::DoDataExchange(CDataExchange* pDX) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CPropertySheet::DoDataExchange(pDX);
}

BOOL CCiSetup::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CPropertySheet::OnCommand(wParam, lParam);
}

void CCiCropCirclePage::OnCancelMode() 
{
	CPropertyPage::OnCancelMode();
	
	// TODO: Add your message handler code here
	
}

BOOL CCiSetupGeometryPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	CComboBox* pCBox = (CComboBox*)GetDlgItem(IDC_SETUP_GEO_VIEW_RANGE);
	if (m_viewRange == 180)
	{
		pCBox->SetCurSel(0);
	}
	else  /* only 150 degrees allowed as of 9/8/03 */ /* changed back to 180/150 6/30/2005*/
	{
		m_viewRange = 150;
		pCBox->SetCurSel(1); // was 1 before 9/8/03
	}
	//OnSelchangeSetupGeoViewRange();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCiSetupGeometryPage::OnSelchangeSetupGeoViewRange() 
{
	CComboBox* pCBox = (CComboBox*)GetDlgItem(IDC_SETUP_GEO_VIEW_RANGE);
	CEdit* pEdit1 = (CEdit*)GetDlgItem(IDC_SETUP_GEO_START_ZEN_ANGLE);
	CEdit* pEdit2 = (CEdit*)GetDlgItem(IDC_SETUP_GEO_END_ZEN_ANGLE);
	int sel = pCBox->GetCurSel();
	if (sel == 0) //selected 180
	{
		m_startZenithAngle = 0;
		m_startZenithAngle = 90;
		pEdit1->SetWindowText("0");
		pEdit2->SetWindowText("90");
	}
	else  /* Only 150 degrees allows as of 9/8/03 *//* changed back to 180/150 6/30/2005 */
	{
		m_startZenithAngle = 0;
		m_startZenithAngle = 75;
		pEdit1->SetWindowText("0");
		pEdit2->SetWindowText("75");
	}
	SetModified(TRUE);
	//UpdateData();
}

void CCiSetupGeometryPage::OnChangeSetupGeoAzmDiv() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	SetModified(TRUE);
	
}

void CCiSetupGeometryPage::OnChangeSetupGeoEndZenAngle() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	SetModified(TRUE);
	
}

void CCiSetupGeometryPage::OnChangeSetupGeoStartZenAngle() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	SetModified(TRUE);
	
}

void CCiSetupGeometryPage::OnChangeSetupGeoThreshLevel() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	SetModified(TRUE);
	
}

void CCiSetupGeometryPage::OnChangeSetupGeoPARcal()
{
	SetModified(TRUE);
}
void CCiSetupGeometryPage::OnChangeSetupGeoPARcal2()
{
	SetModified(TRUE);
}
void CCiSetupGeometryPage::OnChangeSetupGeoFleckscal1()
{
	SetModified(TRUE);
}
void CCiSetupGeometryPage::OnChangeSetupGeoFleckscal2()
{
	SetModified(TRUE);
}
void CCiSetupGeometryPage::OnChangeSetupGeoLatitude()
{
	SetModified(TRUE);
}
void CCiSetupGeometryPage::OnChangeSetupGeoMonth1()
{
	SetModified(TRUE);
}
void CCiSetupGeometryPage::OnChangeSetupGeoDay1()
{
	SetModified(TRUE);
}
void CCiSetupGeometryPage::OnChangeSetupGeoMonth2()
{
	SetModified(TRUE);
}
void CCiSetupGeometryPage::OnChangeSetupGeoDay2()
{
	SetModified(TRUE);
}


void CCiSetupGeometryPage::OnChangeSetupGeoZenDiv() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	SetModified(TRUE);
}

void CCiSetupOutputPage::OnSetupOutputK() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnSetupOutputLai() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnSetupOutputLd() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnSetupOutputMfia() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnSetupOutputTd() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnSetupOutputTr() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnSetupOutputPAR() 
{
	//SetModified(TRUE);
}
void CCiSetupOutputPage::OnSetupOutputLATITUDE() 
{
	//SetModified(TRUE);
}
void CCiSetupOutputPage::OnSetupOutputMONTH1() 
{
	//SetModified(TRUE);
}
void CCiSetupOutputPage::OnSetupOutputDAY1() 
{
	//SetModified(TRUE);
}
void CCiSetupOutputPage::OnSetupOutputMONTH2() 
{
	//SetModified(TRUE);
}
void CCiSetupOutputPage::OnSetupOutputDAY2() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnDoubleclickedSetupOutputK() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnDoubleclickedSetupOutputLai() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnDoubleclickedSetupOutputLd() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnDoubleclickedSetupOutputMfia() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnDoubleclickedSetupOutputTd() 
{
	//SetModified(TRUE);
}

void CCiSetupOutputPage::OnDoubleclickedSetupOutputTr() 
{
	//SetModified(TRUE);	
}

void CCiSetupOutputPage::OnDoubleclickedSetupOutputPAR() 
{
	//SetModified(TRUE);	
}
void CCiSetupOutputPage::OnDoubleclickedSetupOutputLATITUDE() 
{
	//SetModified(TRUE);	
}

void CCiCropCirclePage::OnChangeCropRadius() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	
	SetModified(TRUE);
}

void CCiCropCirclePage::OnChangeCropX() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	
	SetModified(TRUE);
}

void CCiCropCirclePage::OnChangeCropY() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CPropertyPage::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	
	SetModified(TRUE);
}
