// CiSetup.h : header file
//
#ifndef _CCISETUP_H_
#define _CCISETUP_H_

#define WM_USERAPPLY WM_USER + 5

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
// CCiCropCirclePage dialog

class CCiCropCirclePage : public CPropertyPage
{
	DECLARE_DYNCREATE(CCiCropCirclePage)

// Construction
public:
	CCiCropCirclePage();   // standard constructor
	~CCiCropCirclePage();

// Dialog Data
	//{{AFX_DATA(CCiCropCirclePage)
	enum { IDD = IDD_CROP_CIRCLE };
	int	radius;
	int	x;
	int	y;
	int blankout_start;
	int blankout_end;
	//}}AFX_DATA
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCiCropCirclePage)
	protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCiCropCirclePage)
	afx_msg void OnCancelMode();
	afx_msg void OnChangeCropRadius();
	afx_msg void OnChangeCropX();
	afx_msg void OnChangeCropY();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CCiSetupOutputPage dialog

class CCiSetupOutputPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CCiSetupOutputPage)

// Construction
public:
	CCiSetupOutputPage();
	~CCiSetupOutputPage();

// Dialog Data
	//{{AFX_DATA(CCiSetupOutputPage)
	enum { IDD = IDD_OUTPUT };
	BOOL	m_output_k;
	BOOL	m_output_LAI;
	BOOL	m_output_LD;
	BOOL	m_output_MFIA;
	BOOL	m_output_TD;
	BOOL	m_output_TR;
	BOOL	m_output_PAR;
	BOOL	m_output_SUNTRACK;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCiSetupOutputPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CCiSetupOutputPage)
	afx_msg void OnSetupOutputK();
	afx_msg void OnSetupOutputLai();
	afx_msg void OnSetupOutputLd();
	afx_msg void OnSetupOutputMfia();
	afx_msg void OnSetupOutputTd();
	afx_msg void OnSetupOutputTr();
	afx_msg void OnSetupOutputPAR();
	afx_msg void OnSetupOutputLATITUDE();
	afx_msg void OnSetupOutputMONTH1();
	afx_msg void OnSetupOutputDAY1();
	afx_msg void OnSetupOutputMONTH2();
	afx_msg void OnSetupOutputDAY2();
	afx_msg void OnDoubleclickedSetupOutputK();
	afx_msg void OnDoubleclickedSetupOutputLai();
	afx_msg void OnDoubleclickedSetupOutputLd();
	afx_msg void OnDoubleclickedSetupOutputMfia();
	afx_msg void OnDoubleclickedSetupOutputTd();
	afx_msg void OnDoubleclickedSetupOutputTr();
	afx_msg void OnDoubleclickedSetupOutputPAR();
	afx_msg void OnDoubleclickedSetupOutputLATITUDE();
	afx_msg void OnDoubleclickedSetupOutputMONTH1();
	afx_msg void OnDoubleclickedSetupOutputDAY1();
	afx_msg void OnDoubleclickedSetupOutputMONTH2();
	afx_msg void OnDoubleclickedSetupOutputDAY2();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};


/////////////////////////////////////////////////////////////////////////////
// CCiSetupGeometryPage dialog

class CCiSetupGeometryPage : public CPropertyPage
{
	DECLARE_DYNCREATE(CCiSetupGeometryPage)

// Construction
public:
	CCiSetupGeometryPage();
	~CCiSetupGeometryPage();

// Dialog Data
	//{{AFX_DATA(CCiSetupGeometryPage)
	enum { IDD = IDD_SETUP_GEOMETRY };
	int		m_AzmuthalDivision;
	int		m_endZenithAngle;
	int		m_startZenithAngle;
	int		m_threshHoldLevel;
	double m_PARzerocal;
	double m_PARspancal;
	double m_Fleckszerocal;
	double m_Flecksspancal;
	double m_Latitude;
	int		m_month1;
	int		m_day1;
	int		m_month2;
	int		m_day2;
	int		m_viewRange;
	int		m_zenithDivision;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CCiSetupGeometryPage)
	public:
	virtual BOOL OnApply();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CCiSetupGeometryPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeSetupGeoViewRange();
	afx_msg void OnChangeSetupGeoAzmDiv();
	afx_msg void OnChangeSetupGeoEndZenAngle();
	afx_msg void OnChangeSetupGeoStartZenAngle();
	afx_msg void OnChangeSetupGeoThreshLevel();
	afx_msg void OnChangeSetupGeoPARcal();
	afx_msg void OnChangeSetupGeoPARcal2();
	afx_msg void OnChangeSetupGeoFleckscal1();
	afx_msg void OnChangeSetupGeoFleckscal2();
	afx_msg void OnChangeSetupGeoLatitude();
	afx_msg void OnChangeSetupGeoMonth1();
	afx_msg void OnChangeSetupGeoDay1();
	afx_msg void OnChangeSetupGeoMonth2();
	afx_msg void OnChangeSetupGeoDay2();
	afx_msg void OnChangeSetupGeoZenDiv();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////
// CCiSetup

class CCiSetup : public CPropertySheet
{
	DECLARE_DYNAMIC(CCiSetup)
public:
	CCiCropCirclePage		cropCirclePage;
	CCiSetupOutputPage		outputPage;
	CCiSetupGeometryPage	geometryPage;

// Construction
public:
	CCiSetup(UINT nIDCaption, CWnd* pParentWnd = NULL,
			UINT iSelectPage = 0);
	CCiSetup(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, 
			UINT iSelectPage = 0);

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCiSetup)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCiSetup();

	// Generated message map functions
protected:
	//{{AFX_MSG(CCiSetup)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
