// DibView.h : interface of the CDibView class
//
/////////////////////////////////////////////////////////////////////////////
#ifndef _CI_DIBVIEW_H_
#define _CI_DIBVIEW_H_

//class CDibView : public CScrollView
class CDibView : public CView
{
private:
	// Size of the loaded image, used for adjustment
	int ImageHeight, ImageWidth;

	//sizes for the scroll window
	CSize	sizeTotal;
	CSize	sizePage;
	CSize	sizeLine;

	//flag for whether it is doing image adjustment
	BOOL	m_imageAdjustment;
	//for mouse dragging
	//the last mouse position recorded.
    CPoint	m_pointMouse;
	//the last image center in view cordinate.
	CPoint	m_image_center;

	//is the mouse click captured.
    BOOL    m_bCaptured;
	//is the circle resizing or not.
	BOOL	m_resizing;

protected: // create from serialization only
	CDibView();
	DECLARE_DYNCREATE(CDibView)

public:

	//draw the rect border and cordinate numbers.
	void	DrawCordinateBorder(CDC* pDC, CRect);
	//draw the camera icon
	void	DrawCameraIcon(CDC* pDC, CRect);

// Attributes
public:
	BOOL	IsImageAdjustment() {return m_imageAdjustment;}
	void	SetImageAdjustment(BOOL adj) {m_imageAdjustment = adj;}
	CDibDoc* GetDocument();
	void	DocToClient(CRect& rect);
	void	DrawBlankoutRegion(int m_blankout_start, int m_blankout_end);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDibView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDibView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDibView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in DibView.cpp
inline CDibDoc* CDibView::GetDocument()
   { return (CDibDoc*)m_pDocument; }
#endif

#endif
/////////////////////////////////////////////////////////////////////////////
