// DibBlankoutDialog.cpp : implementation file
//

#include "stdafx.h"
#include "dib.h"
#include "DibBlankoutDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CiConfigGeometry* ci_config_geometry;
extern CMainFrame* mainFrame;

/////////////////////////////////////////////////////////////////////////////
// CDibBlankoutDialog dialog
//FILE *fp_log;

CDibBlankoutDialog::CDibBlankoutDialog(CDibDoc* pDoc, CWnd* pParent /*=NULL*/)
	: CDialog(CDibBlankoutDialog::IDD, pParent)
{
	this->pDoc = pDoc;
	m_blankout_flag = FALSE;
	blankout_applied = FALSE;
	/*
    if( ( fp_log = fopen( "ci110.log", "w" ) ) == NULL )
	{
	}
	*/
	//{{AFX_DATA_INIT(CDibBlankoutDialog)
	m_blankout_start = 0;
	m_blankout_end = 0;
	m_thresh_level = 0;
	//}}AFX_DATA_INIT
}

void CDibBlankoutDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
/*
	if (GetDlgItem(IDC_MEASURESETUP_BLANKOUT_START) == NULL)
	{
		fprintf(fp_log, "DoDataExchange(), GetDlgItem(IDC_MEASURESETUP_BLANKOUT_START) == NULL.\n");
		fflush(fp_log);
	}
	//else
	if (GetDlgItem(IDC_MEASURESETUP_BLANKOUT_END) == NULL)
	{
		fprintf(fp_log, "DoDataExchange(), GetDlgItem(IDC_MEASURESETUP_BLANKOUT_END) == NULL.\n");
		fflush(fp_log);
	}
	else
	if (GetDlgItem(IDC_THRESH_LEVEL) == NULL)
	{
		fprintf(fp_log, "DoDataExchange(), GetDlgItem(IDC_THRESH_LEVEL) == NULL.\n");
		fflush(fp_log);
	}
	//else
	*/
	//{{AFX_DATA_MAP(CDibBlankoutDialog)
		DDX_Text(pDX, IDC_MEASURESETUP_BLANKOUT_START, m_blankout_start);
	DDV_MinMaxInt(pDX, m_blankout_start, 0, 359);
		DDX_Text(pDX, IDC_MEASURESETUP_BLANKOUT_END, m_blankout_end);	
	DDV_MinMaxInt(pDX, m_blankout_end, 0, 359);
		DDX_Text(pDX, IDC_THRESH_LEVEL, m_thresh_level);	
	DDV_MinMaxInt(pDX, m_thresh_level, 0, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDibBlankoutDialog, CDialog)
	//{{AFX_MSG_MAP(CDibBlankoutDialog)
	ON_BN_CLICKED(IDC_RADIO_NO, OnRadioNo)
	ON_BN_CLICKED(IDC_RADIO_YES, OnRadioYes)
	ON_BN_CLICKED(IDC_BUTTON_APPLY, OnButtonApply)
	ON_BN_CLICKED(IDC_BUTTON_OK, OnButtonOk)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL, OnButtonCancel)
	ON_EN_CHANGE(IDC_THRESH_LEVEL, OnChangeThreshLevel)
	ON_EN_CHANGE(IDC_MEASURESETUP_BLANKOUT_END, OnChangeMeasuresetupBlankoutEnd)
	ON_EN_CHANGE(IDC_MEASURESETUP_BLANKOUT_START, OnChangeMeasuresetupBlankoutStart)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDibBlankoutDialog message handlers

void CDibBlankoutDialog::OnRadioNo() 
{
	m_blankout_flag = FALSE;
	if (GetDlgItem(IDC_MEASURESETUP_BLANKOUT_START) == NULL)
	{
		//fprintf(fp_log, "OnRadioNo(), GetDlgItem(IDC_MEASURESETUP_BLANKOUT_START) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CEdit*)GetDlgItem(IDC_MEASURESETUP_BLANKOUT_START))->EnableWindow(FALSE);
	if (GetDlgItem(IDC_MEASURESETUP_BLANKOUT_END) == NULL)
	{
		//fprintf(fp_log, "OnRadioNo(), GetDlgItem(IDC_MEASURESETUP_BLANKOUT_END) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CEdit*)GetDlgItem(IDC_MEASURESETUP_BLANKOUT_END))->EnableWindow(FALSE);
	if (GetDlgItem(IDC_BUTTON_APPLY) == NULL)
	{
		//fprintf(fp_log, "OnRadioNo(), GetDlgItem(IDC_BUTTON_APPLY) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CButton*)GetDlgItem(IDC_BUTTON_APPLY))->EnableWindow(TRUE);
	if (GetDlgItem(IDC_SPIN1) == NULL)
	{
		//fprintf(fp_log, "OnRadioNo(), GetDlgItem(IDC_SPIN1) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN1))->EnableWindow(FALSE);
	if (GetDlgItem(IDC_SPIN2) == NULL)
	{
		//fprintf(fp_log, "OnRadioNo(), GetDlgItem(IDC_SPIN2) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN2))->EnableWindow(FALSE);

	DrawBlankoutRegion();
}

void CDibBlankoutDialog::OnRadioYes() 
{
	m_blankout_flag = TRUE;
	if (GetDlgItem(IDC_MEASURESETUP_BLANKOUT_START) == NULL)
	{
		//fprintf(fp_log, "OnRadioYes(), GetDlgItem(IDC_MEASURESETUP_BLANKOUT_START) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CEdit*)GetDlgItem(IDC_MEASURESETUP_BLANKOUT_START))->EnableWindow(TRUE);
	if (GetDlgItem(IDC_MEASURESETUP_BLANKOUT_END) == NULL)
	{
		//fprintf(fp_log, "OnRadioYes(), GetDlgItem(IDC_MEASURESETUP_BLANKOUT_END) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CEdit*)GetDlgItem(IDC_MEASURESETUP_BLANKOUT_END))->EnableWindow(TRUE);
	if (GetDlgItem(IDC_BUTTON_APPLY) == NULL)
	{
		//fprintf(fp_log, "OnRadioYes(), GetDlgItem(IDC_BUTTON_APPLY) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CButton*)GetDlgItem(IDC_BUTTON_APPLY))->EnableWindow(TRUE);
	if (GetDlgItem(IDC_SPIN1) == NULL)
	{
		//fprintf(fp_log, "OnRadioYes(), GetDlgItem(IDC_SPIN1) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN1))->EnableWindow(TRUE);
	if (GetDlgItem(IDC_SPIN2) == NULL)
	{
		//fprintf(fp_log, "OnRadioYes(), GetDlgItem(IDC_SPIN2) == NULL.\n");
		//fflush(fp_log);
	}
	else
		((CSpinButtonCtrl*)GetDlgItem(IDC_SPIN2))->EnableWindow(TRUE);

	DrawBlankoutRegion();
}

void CDibBlankoutDialog::UpdateState()
{
	m_blankout_flag = ci_config_geometry->blankout_flag;

	if (ci_config_geometry->blankout_flag)
	{
		//((CButton*)GetDlgItem(IDC_RADIO_NO))->SetCheck(1);
		m_blankout_start = ci_config_geometry->blankout1;
		m_blankout_end = ci_config_geometry->blankout2;
		//OnRadioYes();
	}
	else
	{
		//((CButton*)GetDlgItem(IDC_RADIO_NO))->SetCheck(0);
		//OnRadioNo();
	}

	m_thresh_level = ci_config_geometry->threshhold_level;
}

void CDibBlankoutDialog::OnButtonApply() 
{
	UpdateData();

	if (m_blankout_flag != ci_config_geometry->blankout_flag)
	{
		blankout_applied = FALSE;
		ci_config_geometry->blankout_flag = m_blankout_flag;
	}
	
	if (m_blankout_flag)
	{
		if (m_blankout_start != ci_config_geometry->blankout1)
		{
			blankout_applied = FALSE;
			ci_config_geometry->blankout1 = m_blankout_start;
		}
		if (m_blankout_end != ci_config_geometry->blankout2)
		{
			blankout_applied = FALSE;
			ci_config_geometry->blankout2 = m_blankout_end;
		}
	}

	if (ci_config_geometry->threshhold_level != m_thresh_level)
	{
		ci_config_geometry->threshhold_level = m_thresh_level;
		blankout_applied = FALSE;
				char visionx[32];
		_itoa(ci_config_geometry->threshhold_level,visionx,10);
			AfxMessageBox(visionx);
	}

	if (ci_config_geometry->PARzerocal != m_PARzerocal)
	{
		ci_config_geometry->PARzerocal = m_PARzerocal;
		blankout_applied = FALSE;
	}

	if (ci_config_geometry->PARspancal != m_PARspancal)
	{
		ci_config_geometry->PARspancal = m_PARspancal;
		blankout_applied = FALSE;
	}
	if (ci_config_geometry->Fleckszerocal != m_Fleckszerocal)
	{
		ci_config_geometry->Fleckszerocal = m_Fleckszerocal;
		blankout_applied = FALSE;
	}

	if (ci_config_geometry->Flecksspancal != m_Flecksspancal)
	{
		ci_config_geometry->Flecksspancal = m_Flecksspancal;
		blankout_applied = FALSE;
	}


	//if (!blankout_applied)
	{
		::SetCursor(::LoadCursor(NULL, IDC_WAIT));
		pDoc->m_drawBlankoutAsLines = FALSE;
		pDoc->SetState(CI_SHOWLEAFIMAGE);
		pDoc->UpdateImages();
		pDoc->UpdateAllViews(NULL);
		::SetCursor(::LoadCursor(NULL, IDC_ARROW));
	}

	blankout_applied = TRUE;
	((CButton*)GetDlgItem(IDC_BUTTON_APPLY))->EnableWindow(FALSE);
}

void CDibBlankoutDialog::OnButtonOk() 
{
	pDoc->m_drawBlankoutAsLines = FALSE;
	POSITION pos = pDoc->GetFirstViewPosition();
	CDibView* pFirstView = (CDibView*)pDoc->GetNextView( pos );
	pFirstView->DrawBlankoutRegion(m_blankout_start, m_blankout_end);

	EndDialog(IDOK);
	OnButtonApply();
}

void CDibBlankoutDialog::OnButtonCancel() 
{
	pDoc->m_drawBlankoutAsLines = FALSE;
	POSITION pos = pDoc->GetFirstViewPosition();
	CDibView* pFirstView = (CDibView*)pDoc->GetNextView( pos );
	pFirstView->DrawBlankoutRegion(m_blankout_start, m_blankout_end);

	EndDialog(IDCANCEL);
}

BOOL CDibBlankoutDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CSpinButtonCtrl* startSB = (CSpinButtonCtrl*)GetDlgItem(IDC_SPIN1);
	startSB->SetPos(m_blankout_start);
	startSB->SetRange(0, 359);
	startSB->SetBase(10);
	CSpinButtonCtrl* endSB = (CSpinButtonCtrl*)GetDlgItem(IDC_SPIN2);
	endSB->SetPos(m_blankout_end);
	endSB->SetRange(0, 359);
	endSB->SetBase(10);
	if (ci_config_geometry->blankout_flag)
	{
		((CButton*)GetDlgItem(IDC_RADIO_YES))->SetCheck(1);
		((CButton*)GetDlgItem(IDC_RADIO_NO))->SetCheck(0);
		m_blankout_start = ci_config_geometry->blankout1;
		m_blankout_end = ci_config_geometry->blankout2;
		OnRadioYes();
	}
	else
	{
		((CButton*)GetDlgItem(IDC_RADIO_YES))->SetCheck(0);
		((CButton*)GetDlgItem(IDC_RADIO_NO))->SetCheck(1);
		OnRadioNo();
	}
	/*
	*/
	m_thresh_level = ci_config_geometry->threshhold_level;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDibBlankoutDialog::OnChangeThreshLevel() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	((CButton*)GetDlgItem(IDC_BUTTON_APPLY))->EnableWindow(TRUE);

}

void CDibBlankoutDialog::DrawBlankoutRegion()
{
	UpdateData();

	ci_config_geometry->blankout_flag = m_blankout_flag;

	if (ci_config_geometry->blankout_flag)
	{
		ci_config_geometry->blankout1 = m_blankout_start;
		ci_config_geometry->blankout2 = m_blankout_end;
	}

	if (pDoc->GetState() == CI_SHOWLEAFIMAGE)
	{
		pDoc->SetState(CI_SHOWCROPPEDIMAGE);
		pDoc->UpdateImages();
	}
	POSITION pos = pDoc->GetFirstViewPosition();
	CDibView* pFirstView = (CDibView*)pDoc->GetNextView( pos );
	pDoc->m_drawBlankoutAsLines = TRUE;
	pFirstView->DrawBlankoutRegion(m_blankout_start, m_blankout_end);
}

BOOL CDibBlankoutDialog::DestroyWindow() 
{
	pDoc->m_drawBlankoutAsLines = FALSE;
	POSITION pos = pDoc->GetFirstViewPosition();
	CDibView* pFirstView = (CDibView*)pDoc->GetNextView( pos );
	pFirstView->DrawBlankoutRegion(m_blankout_start, m_blankout_end);
	
	return CDialog::DestroyWindow();
}

void CDibBlankoutDialog::OnChangeMeasuresetupBlankoutEnd() 
{
	mainFrame->setConfigChanged(TRUE);

	blankout_applied = FALSE;
	
	DrawBlankoutRegion();
	
	((CButton*)GetDlgItem(IDC_BUTTON_APPLY))->EnableWindow(TRUE);
}

void CDibBlankoutDialog::OnChangeMeasuresetupBlankoutStart() 
{
	mainFrame->setConfigChanged(TRUE);

	blankout_applied = FALSE;
	
	DrawBlankoutRegion();

	((CButton*)GetDlgItem(IDC_BUTTON_APPLY))->EnableWindow(TRUE);
}
