// MainFrm.cpp : implementation of the CMainFrame class
//           3.1 is for Sunfleck model
// 03May2007 3.1.0.6 (second try) added negative latitudes for Southern Hemisphere
// 18May2007 3.1.0.7 fixed toolbar.bmp again, added tooltip for PAR and Sunflecks.


#include <windowsx.h> 

#include "stdafx.h"
#include "Dib.h"
#include <windows.h>
#include <mmsystem.h>
#include <mmreg.h>
#include <msacm.h>    // Audio Compression Manager
#include "Eztwain.h"
#include "CiConfig.h"

#include "MainFrm.h"
#include "DibDoc.h"
#include "DibView.h"



#include <vfw.h>
#include <math.h>
#include <stdio.h>
#include <process.h>


#include <malloc.h>


#include <afxdisp.h>


#include <setupapi.h>
#include <devguid.h>
#include <regstr.h>

#pragma comment( lib, "setupapi.lib")

// Belkin:	{4D36E96C-E325-11CE-BFC1-08002BE10318}
// {17CCA71B-ECD7-11D0-B908-00A0C9223196}
/*Multimedia
	Class = Media
	ClassGuid = {4d36e96c-e325-11ce-bfc1-08002be10318}

	This class includes Audio and DVD multimedia devices, joystick ports, and full-motion video capture devices. 
*/

#include <initguid.h>
//DEFINE_GUID(GUID_BELKINAUDIO, 0x4D36E96C, 0xE325, 0x11CE, 0xBF, 0xC1, 0x08,
			//0x00, 0x2B, 0xE1, 0x03, 0x18);
//DEFINE_GUID(GUID_BELKINAUDIO1, 0x17CCA71B, 0xECD7, 0x11D0, 0xB9, 0x08, 0x00,
			//0xA0, 0xC9, 0x22, 0x31, 0x96);


#define MMCAPS_DEVTYPE_WAVEIN		7


double Flecksgain = .0014;
double PARgain=0.00055;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CiConfigImage* ci_config_image;
CiConfigNetwork* ci_config_network;
CiConfigOutput* ci_config_output;
CiConfigGeometry* ci_config_geometry;
CiConfigMeasure* ci_config_measure;

UINT PARThreadProc(LPVOID pParam);

typedef struct{
	double PAR;
	double Flecks;
	int measure;
	int count;
	bool bTESTOUT;
} PARFlecks;

   PARFlecks * pPARFlecks;
   PARFlecks PARFlecksValue;

   double PAR,Flecks;

CMainFrame* mainFrame;

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_ACQUIRE, OnUpdateAcquire)
	ON_COMMAND(ID_ACQUIRE, OnAcquire)
//	ON_UPDATE_COMMAND_UI(ID_SUNFLECKS, OnUpdateAcquire)
	ON_COMMAND(ID_SUNFLECKS, OnSunflecks)
	ON_UPDATE_COMMAND_UI(ID_SELECT_SOURCE, OnUpdateSelectSource)
	ON_COMMAND(ID_SELECT_SOURCE, OnSelectSource)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_PALETTECHANGED()
	ON_WM_QUERYNEWPALETTE()
	ON_COMMAND(ID_OPTIONS_SETUP, OnOptionsSetup)
	ON_COMMAND(ID_ACQUIRE_CLIPBOARD, OnAcquireClipboard)
	ON_UPDATE_COMMAND_UI(ID_ACQUIRE_CLIPBOARD, OnUpdateAcquireClipboard)
	ON_MESSAGE(WM_USERAPPLY, OnUserApply)
	ON_COMMAND(IDC_IMAGE_MEASURE, OnImageMeasure)
	ON_UPDATE_COMMAND_UI(IDC_IMAGE_MEASURE, OnUpdateImageMeasure)
	ON_COMMAND(IDC_IMAGE_MEASURE_PREPARE, OnImageMeasurePrepare)
	ON_UPDATE_COMMAND_UI(IDC_IMAGE_MEASURE_PREPARE, OnUpdateImageMeasurePrepare)
	ON_COMMAND(ID_OPTIONS_SAVE, OnOptionsSave)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SAVE, OnUpdateOptionsSave)
	ON_COMMAND(IDC_IMAGE_ADJUSTMENT, OnImageAdjustment)
	ON_UPDATE_COMMAND_UI(IDC_IMAGE_ADJUSTMENT, OnUpdateImageAdjustment)
	ON_COMMAND(ID_BUTTON_ADJUSTMENT, OnButtonAdjustment)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_ADJUSTMENT, OnUpdateButtonAdjustment)
	ON_COMMAND(ID_BUTTON_MEASURE, OnButtonMeasure)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_MEASURE, OnUpdateButtonMeasure)
	ON_COMMAND(IDC_IMAGE_CLEARALL, OnImageClearall)
	ON_UPDATE_COMMAND_UI(IDC_IMAGE_CLEARALL, OnUpdateImageClearall)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_SETUP, OnUpdateOptionsSetup)
	ON_COMMAND(IDC_IMAGE_REFRESH, OnImageRefresh)
	ON_UPDATE_COMMAND_UI(IDC_IMAGE_REFRESH, OnUpdateImageRefresh)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVEPROCESSEDIMAGE, OnUpdateFileSaveprocessedimage)
	ON_COMMAND(ID_FILE_SAVEPROCESSEDIMAGE, OnFileSaveprocessedimage)
	ON_COMMAND(ID_VIEW_WINDOW_SCALE_3QUARTER, OnViewWindowScale3quarter)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOW_SCALE_3QUARTER, OnUpdateViewWindowScale3quarter)
	ON_COMMAND(ID_VIEW_WINDOW_SCALE_5SIXTH, OnViewWindowScale5sixth)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOW_SCALE_5SIXTH, OnUpdateViewWindowScale5sixth)
	ON_COMMAND(ID_VIEW_WINDOW_SCALE_7EIGTH, OnViewWindowScale7eigth)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOW_SCALE_7EIGTH, OnUpdateViewWindowScale7eigth)
	ON_COMMAND(ID_VIEW_WINDOW_SCALE_FULL, OnViewWindowScaleFull)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOW_SCALE_FULL, OnUpdateViewWindowScaleFull)
	ON_COMMAND(ID_VIEW_WINDOW_SCALE_PLUS50, OnViewWindowScalePlus50)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOW_SCALE_PLUS50, OnUpdateViewWindowScalePlus50)
	ON_COMMAND(ID_VIEW_WINDOW_SCALE_HALF, OnViewWindowScaleHalf)
	ON_UPDATE_COMMAND_UI(ID_VIEW_WINDOW_SCALE_HALF, OnUpdateViewWindowScaleHalf)
	ON_WM_SIZE()
	ON_COMMAND(ID_CIDFILE_PRINT, OnFilePrint)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,			// status line indicator
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame() : setupPS("")
{
	CWinThread * PAR_Thread;

	mainFrame = this;

	ci_config_image = new CiConfigImage();
	ci_config_network = new CiConfigNetwork();
	ci_config_geometry = new CiConfigGeometry();
	ci_config_output = new CiConfigOutput();
	ci_config_measure = new CiConfigMeasure();

	needResize = TRUE;
	if (GetCurrentDirectory(256, &launchDirectory[0]) == 0)
		launchDirectory[0] = 0;

	ReadConfigFile();
	pPARFlecks=	(PARFlecks*)&PARFlecksValue;
	PARFlecksValue.measure=0;      // OnAquire sets this to 1 to start the PAR measurement
	PARFlecksValue.count=0;
	PARFlecksValue.bTESTOUT=FALSE; //set to true if you want to save a .wav file for the first buffer of audio
	PAR_Thread = AfxBeginThread( PARThreadProc,(LPVOID) pPARFlecks,THREAD_PRIORITY_TIME_CRITICAL);

}

CMainFrame::~CMainFrame()
{
}

void CMainFrame::ReadConfigFile()
{
	FILE	*fp;
	char	version[32];

	if( ( fp = fopen( "ci110.cfg", "r" ) ) == NULL )
	{
		configChanged = TRUE;
		return;
	}
	fscanf(fp, "CI110 Version        : %s\n", version);
	if(strncmp(version, VERSION, 6)) {
		configChanged = TRUE;	/* Need a new config file				*/
		if(strncmp(version,"V3.0.1", 6)==0) // old version, so load old config file
		{
			fscanf(fp, "Configuration file for CI110 program.\n");
			fscanf(fp, "Please do not modify by hand.\n\n");
			fscanf(fp, "\nOption Setup         :\n" );
			fscanf(fp, "Zenith divisions     : %d\n",  &ci_config_geometry->num_of_zenith_division );
			fscanf(fp, "Azimuthal divisions  : %d\n",  &ci_config_geometry->num_of_azmuthal_division );
			fscanf(fp, "Start Zenith Angle   : %d\n",  &ci_config_geometry->starting_zenith_angle);
			fscanf(fp, "End Zenith Angle     : %d\n",  &ci_config_geometry->ending_zenith_angle);
			fscanf(fp, "View range (degree)  : %d\n",  &ci_config_geometry->view_range );
			fscanf(fp, "Blankout flag        : %d\n",  &ci_config_geometry->blankout_flag );
			fscanf(fp, "Blankout angle 1     : %d\n", &ci_config_geometry->blankout1 );
			fscanf(fp, "Blankout angle 2     : %d\n", &ci_config_geometry->blankout2 );
			fscanf(fp, "Threshold level (%%)  : %d\n", &ci_config_geometry->threshhold_level );
			fscanf(fp, "PARzerocal       : %lf\n", &ci_config_geometry->PARzerocal );

			fscanf(fp, "\nOutput Setup         :\n" );
			fscanf(fp, "LAI                  : %d\n", &ci_config_output->bLAI);
			fscanf(fp, "LD                   : %d\n", &ci_config_output->bLD);
			fscanf(fp, "MFIA                 : %d\n", &ci_config_output->bMFIA);
			fscanf(fp, "TR                   : %d\n", &ci_config_output->bTR);
			fscanf(fp, "TD                   : %d\n", &ci_config_output->bTD);
			fscanf(fp, "K                    : %d\n", &ci_config_output->bK);
			fscanf(fp, "PAR                  : %d\n", &ci_config_output->bPAR);

			fscanf(fp, "\nImage Setup         :\n" );
			fscanf(fp, "Maximum Radius       : %d\n", &ci_config_image->radius);
			fscanf(fp, "Camera Center in X   : %d\n", &ci_config_image->center_x);
			fscanf(fp, "Camera Center in Y   : %d\n", &ci_config_image->center_y);
			// Handling new image size 800x600. For simplicity, we only handle two
			// sets of image sizes, 800x600 and 640x480. If the size is not specified
			// as 800x600, the image size is set to 640x480
			// as of 3040 768x494
			int tmpx = 0, tmpy = 0;
			fscanf(fp, "Image Width          : %d\n", &tmpx);
			fscanf(fp, "Image Height         : %d\n", &tmpy);

			if (tmpx == 800 && tmpy == 600)
			{
				ci_config_image->max_msrbl_image_x = 599;
				ci_config_image->max_msrbl_image_y = 599;
			}
			else
				if(tmpx == 768 && tmpy==494)
				{
				   ci_config_image->max_msrbl_image_x = 493;
				   ci_config_image->max_msrbl_image_y = 493;
				}
				else

			{
				ci_config_image->max_msrbl_image_x = min(DEFAULT_MAX_IMAGE_X, DEFAULT_MAX_IMAGE_Y);
				ci_config_image->max_msrbl_image_y = ci_config_image->max_msrbl_image_x;
			}
	
		}
		else if(strncmp(version,"V3.0.2", 6)==0) // old version, so load old config file
		{
			fscanf(fp, "Configuration file for CI110 program.\n");
			fscanf(fp, "Please do not modify by hand.\n\n");
			fscanf(fp, "\nOption Setup         :\n" );
			fscanf(fp, "Zenith divisions     : %d\n",  &ci_config_geometry->num_of_zenith_division );
			fscanf(fp, "Azimuthal divisions  : %d\n",  &ci_config_geometry->num_of_azmuthal_division );
			fscanf(fp, "Start Zenith Angle   : %d\n",  &ci_config_geometry->starting_zenith_angle);
			fscanf(fp, "End Zenith Angle     : %d\n",  &ci_config_geometry->ending_zenith_angle);
			fscanf(fp, "View range (degree)  : %d\n",  &ci_config_geometry->view_range );
			fscanf(fp, "Blankout flag        : %d\n",  &ci_config_geometry->blankout_flag );
			fscanf(fp, "Blankout angle 1     : %d\n", &ci_config_geometry->blankout1 );
			fscanf(fp, "Blankout angle 2     : %d\n", &ci_config_geometry->blankout2 );
			fscanf(fp, "Threshold level (%%)  : %d\n", &ci_config_geometry->threshhold_level );
			fscanf(fp, "PARzerocal       : %lf\n", &ci_config_geometry->PARzerocal );
			fscanf(fp, "Latitude             : %lf\n", &ci_config_geometry->Latitude );
			fscanf(fp, "Month1               : %d\n", &ci_config_geometry->Month1 );
			fscanf(fp, "Day1                 : %d\n", &ci_config_geometry->Day1 );
			fscanf(fp, "Month2               : %d\n", &ci_config_geometry->Month2 );
			fscanf(fp, "Day2                 : %d\n", &ci_config_geometry->Day2 );
	
			fscanf(fp, "\nOutput Setup         :\n" );
			fscanf(fp, "LAI                  : %d\n", &ci_config_output->bLAI);
			fscanf(fp, "LD                   : %d\n", &ci_config_output->bLD);
			fscanf(fp, "MFIA                 : %d\n", &ci_config_output->bMFIA);
			fscanf(fp, "TR                   : %d\n", &ci_config_output->bTR);
			fscanf(fp, "TD                   : %d\n", &ci_config_output->bTD);
			fscanf(fp, "K                    : %d\n", &ci_config_output->bK);
			fscanf(fp, "PAR                  : %d\n", &ci_config_output->bPAR);
			fscanf(fp, "SUN TRACK            : %d\n", &ci_config_output->bSUNTRACK);

			fscanf(fp, "\nImage Setup         :\n" );
			fscanf(fp, "Maximum Radius       : %d\n", &ci_config_image->radius);
			fscanf(fp, "Camera Center in X   : %d\n", &ci_config_image->center_x);
			fscanf(fp, "Camera Center in Y   : %d\n", &ci_config_image->center_y);
			fscanf(fp, "Image type           : %s\n", &ci_config_image->type);
			// Handling new image size 800x600. For simplicity, we only handle two
			// sets of image sizes, 800x600 and 640x480. If the size is not specified
			// as 800x600, the image size is set to 640x480
			// as of 3040 768x494 also handled
			int tmpx = 0, tmpy = 0;
			fscanf(fp, "Image Width          : %d\n", &tmpx);
			fscanf(fp, "Image Height         : %d\n", &tmpy);

			if (tmpx == 800 && tmpy == 600)
			{
				ci_config_image->max_msrbl_image_x = 599;
				ci_config_image->max_msrbl_image_y = 599;
			}
			else
				if(tmpx == 768 && tmpy==494)
				{
				   ci_config_image->max_msrbl_image_x = 493;
				   ci_config_image->max_msrbl_image_y = 493;
				}
				else

			{
				ci_config_image->max_msrbl_image_x = min(DEFAULT_MAX_IMAGE_X, DEFAULT_MAX_IMAGE_Y);
				ci_config_image->max_msrbl_image_y = ci_config_image->max_msrbl_image_x;
			}
	
		}
		fclose(fp);
		return;
	}

	configChanged = FALSE;		/* Load config file 					*/

	fscanf(fp, "Configuration file for CI110 program.\n");
	fscanf(fp, "Please do not modify by hand.\n\n");
	fscanf(fp, "\nOption Setup         :\n" );
	fscanf(fp, "Zenith divisions     : %d\n",  &ci_config_geometry->num_of_zenith_division );
	fscanf(fp, "Azimuthal divisions  : %d\n",  &ci_config_geometry->num_of_azmuthal_division );
	fscanf(fp, "Start Zenith Angle   : %d\n",  &ci_config_geometry->starting_zenith_angle);
	fscanf(fp, "End Zenith Angle     : %d\n",  &ci_config_geometry->ending_zenith_angle);
	fscanf(fp, "View range (degree)  : %d\n",  &ci_config_geometry->view_range );
	fscanf(fp, "Blankout flag        : %d\n",  &ci_config_geometry->blankout_flag );
	fscanf(fp, "Blankout angle 1     : %d\n", &ci_config_geometry->blankout1 );
	fscanf(fp, "Blankout angle 2     : %d\n", &ci_config_geometry->blankout2 );
	fscanf(fp, "Threshold level (%%)  : %d\n", &ci_config_geometry->threshhold_level );
	fscanf(fp, "PARzerocal           : %lf\n", &ci_config_geometry->PARzerocal );
	fscanf(fp, "PARspancal           : %lf\n", &ci_config_geometry->PARspancal );
	fscanf(fp, "Fleckszerocal         : %lf\n", &ci_config_geometry->Fleckszerocal );
	fscanf(fp, "Flecksspancal         : %lf\n", &ci_config_geometry->Flecksspancal );
	fscanf(fp, "Latitude             : %lf\n", &ci_config_geometry->Latitude );
	fscanf(fp, "Month1               : %d\n", &ci_config_geometry->Month1 );
	fscanf(fp, "Day1                 : %d\n", &ci_config_geometry->Day1 );
	fscanf(fp, "Month2               : %d\n", &ci_config_geometry->Month2 );
	fscanf(fp, "Day2                 : %d\n", &ci_config_geometry->Day2 );

	fscanf(fp, "\nOutput Setup         :\n" );
	fscanf(fp, "LAI                  : %d\n", &ci_config_output->bLAI);
	fscanf(fp, "LD                   : %d\n", &ci_config_output->bLD);
	fscanf(fp, "MFIA                 : %d\n", &ci_config_output->bMFIA);
	fscanf(fp, "TR                   : %d\n", &ci_config_output->bTR);
	fscanf(fp, "TD                   : %d\n", &ci_config_output->bTD);
	fscanf(fp, "K                    : %d\n", &ci_config_output->bK);
	fscanf(fp, "PAR                  : %d\n", &ci_config_output->bPAR);
	fscanf(fp, "SUN TRACK            : %d\n", &ci_config_output->bSUNTRACK);

	fscanf(fp, "\nImage Setup         :\n" );
	fscanf(fp, "Maximum Radius       : %d\n", &ci_config_image->radius);
	fscanf(fp, "Camera Center in X   : %d\n", &ci_config_image->center_x);
	fscanf(fp, "Camera Center in Y   : %d\n", &ci_config_image->center_y);
	fscanf(fp, "Image type           : %s\n", &ci_config_image->type);
	// Handling new image size 800x600. For simplicity, we only handle two
	// sets of image sizes, 800x600 and 640x480. If the size is not specified
	// as 800x600, the image size is set to 640x480
	// as of 3040 768x494 also handled
	int tmpx = 0, tmpy = 0;
	fscanf(fp, "Image Width          : %d\n", &tmpx);
	fscanf(fp, "Image Height         : %d\n", &tmpy);
	if (tmpx == 800 && tmpy == 600)
	{
		ci_config_image->max_msrbl_image_x = 599;
		ci_config_image->max_msrbl_image_y = 599;
	}
	else
	if (tmpx == 768 && tmpy == 494)
	{
		ci_config_image->max_msrbl_image_x = 493;
		ci_config_image->max_msrbl_image_y = 493;
	}
	else
	{
		ci_config_image->max_msrbl_image_x = min(DEFAULT_MAX_IMAGE_X, DEFAULT_MAX_IMAGE_Y);
		ci_config_image->max_msrbl_image_y = ci_config_image->max_msrbl_image_x;
	}

	fclose(fp);
	return;
}

void CMainFrame::SaveConfigFile()
{
	FILE	*fp;

	if(strcmp(ci_config_image->type,"bmp")!=0)strcpy(ci_config_image->type,"jpg");

	char curDir[256];
	if (GetCurrentDirectory(256, &curDir[0]) == 0)
		curDir[0] = 0;
	if (launchDirectory[0] != 0)
		SetCurrentDirectory(&launchDirectory[0]);

	if( ( fp = fopen( "ci110.cfg", "w" ) ) == NULL )
	{
		return;
	}
	fprintf(fp, "CI110 Version        : %s\n", VERSION);

	fprintf(fp, "Configuration file for CI110 program.\n");
	fprintf(fp, "Please do not modify by hand.\n\n");

	fprintf(fp, "\nOption Setup         :\n" );
	fprintf(fp, "Zenith divisions     : %d\n",	ci_config_geometry->num_of_zenith_division );
	fprintf(fp, "Azimuthal divisions  : %d\n",	ci_config_geometry->num_of_azmuthal_division );
	fprintf(fp, "Start Zenith Angle   : %d\n",	ci_config_geometry->starting_zenith_angle);
	fprintf(fp, "End Zenith Angle     : %d\n",	ci_config_geometry->ending_zenith_angle);
	fprintf(fp, "View range (degree)  : %d\n",	ci_config_geometry->view_range );
	fprintf(fp, "Blankout flag        : %d\n",	ci_config_geometry->blankout_flag );
	fprintf(fp, "Blankout angle 1     : %d\n", ci_config_geometry->blankout1 );
	fprintf(fp, "Blankout angle 2     : %d\n", ci_config_geometry->blankout2 );
	fprintf(fp, "Threshold level (%%)  : %d\n", ci_config_geometry->threshhold_level );
	fprintf(fp, "PARzerocal           : %2.6f\n", ci_config_geometry->PARzerocal );
	fprintf(fp, "PARspancal           : %2.6f\n", ci_config_geometry->PARspancal );
	fprintf(fp, "Fleckszerocal         : %2.6f\n", ci_config_geometry->Fleckszerocal );
	fprintf(fp, "Flecksspancal         : %2.6f\n", ci_config_geometry->Flecksspancal );
	fprintf(fp, "Latitude             : %2.6f\n", ci_config_geometry->Latitude );
	fprintf(fp, "Month1               : %d\n", ci_config_geometry->Month1 );
	fprintf(fp, "Day1                 : %d\n", ci_config_geometry->Day1 );
	fprintf(fp, "Month2               : %d\n", ci_config_geometry->Month2 );
	fprintf(fp, "Day2                 : %d\n", ci_config_geometry->Day2 );

	fprintf(fp, "\nOutput Setup         :\n" );
	fprintf(fp, "LAI                  : %d\n", ci_config_output->bLAI);
	fprintf(fp, "LD                   : %d\n", ci_config_output->bLD);
	fprintf(fp, "MFIA                 : %d\n", ci_config_output->bMFIA);
	fprintf(fp, "TR                   : %d\n", ci_config_output->bTR);
	fprintf(fp, "TD                   : %d\n", ci_config_output->bTD);
	fprintf(fp, "K                    : %d\n", ci_config_output->bK);
	fprintf(fp, "PAR                  : %d\n", ci_config_output->bPAR);
	fprintf(fp, "SUN TRACK            : %d\n", ci_config_output->bSUNTRACK);

	fprintf(fp, "\nImage Setup         :\n" );
	fprintf(fp, "Maximum Radius       : %d\n", ci_config_image->radius);
	fprintf(fp, "Camera Center in X   : %d\n", ci_config_image->center_x);
	fprintf(fp, "Camera Center in Y   : %d\n", ci_config_image->center_y);
	fprintf(fp, "Image type           : %s\n", ci_config_image->type);
	// Handling new image size 800x600
	if (ci_config_image->max_msrbl_image_x == 599)
	{
		fprintf(fp, "Image Width          : %d\n", 800);
		fprintf(fp, "Image Height         : %d\n", 600);
	}
	else
	if (ci_config_image->max_msrbl_image_x == 493)
	{
		fprintf(fp, "Image Width          : %d\n", 768);
		fprintf(fp, "Image Height         : %d\n", 494);
	}
	else
	{
		fprintf(fp, "Image Width          : %d\n", 640);
		fprintf(fp, "Image Height         : %d\n", 480);
	}

	configChanged = FALSE;

	fclose(fp);

	if (curDir[0] != 0)
		SetCurrentDirectory(&curDir[0]);

	return;
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;		// fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;		// fail to create
	}
	/*** old code, used CTwain's functions
		if (TwainAvailable()) {
		SetDefWindow(this);
		if (!OpenSourceManager()) {
			// OpenSourceManager does not report errors
			TwainError(TWERR_OPEN_DSM);
		}
	}
	*/
	if (TWAIN_IsAvailable()) {
		if (!TWAIN_OpenSourceManager(m_hWnd)) {
			// OpenSourceManager does not report errors
			TwainError(TWERR_OPEN_DSM);
		}
	}
	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//	be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar, AFX_IDW_DOCKBAR_LEFT);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style &= ~WS_THICKFRAME;
	cs.style &= ~WS_MAXIMIZEBOX; 
	cs.cx = WINDOW_SIZE_X;
	cs.cy = WINDOW_SIZE_Y;

	return CFrameWnd::PreCreateWindow(cs);
}

void CMainFrame::TwainError(TW_ERR e)
{
	AfxMessageBox("A TWAIN error occurred.", MB_ICONINFORMATION | MB_OK);
} // TwainError

void CMainFrame::DibReceived(HGLOBAL hdib)
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		((CDibDoc*) pDoc)->SetState(CI_INITIALIZED);
		((CDibDoc*) pDoc)->SetOriginalDib(hdib);
		((CDibDoc*) pDoc)->SetModifiedFlag(TRUE);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


/////////////////////////////////////////////////////////////////////////////

//PAR Flecks
UINT PARThreadProc(LPVOID pParam)
{
/******************************************************************************************************************/
   UINT uResult=0;
   PARFlecks* pPARFlecksV=(PARFlecks*)pParam;

   FILE *testout=NULL;
   COleDateTime timeStart, timeEnd;
   COleDateTimeSpan spanElapsed;
   TCHAR      ach[128];
   MMRESULT   mmr;
   int        n,whbuffer;
   int        nDevs;
   int        nIndex,itmp;
   LPARAM     lParam;
   UINT       uDevType,ubcnt,uparcnt,uinterval,upar[24],uFlecks[24],un;
   int        ipar[24],iFlecks[24];
   unsigned short int ucnt,uval;
   unsigned int numwritten=0;
   bool bNoValue;
   HWAVEIN hwi;
   WAVEFORMATEX wfx;

#define MAXWAV 8192
#define MAXAVG 12
   // maxavg must be less than the dimensions above (24)
#define MAXWAVCNT 10

   char *wavebuffer[MAXWAVCNT];
   char MsgBuf[255];

   unsigned char c1,c2;
   WAVEHDR wh[MAXWAVCNT];
   UINT cbwh=sizeof(WAVEHDR);
   bool bFilesave=PARFlecksValue.bTESTOUT;
   while(1)
   {
      if(PARFlecksValue.measure)
      {
         bNoValue=TRUE;
         nDevs = waveInGetNumDevs();
         for (n = -1; n < nDevs; n++)
         {
            WAVEINCAPS    wic;
            mmr = waveInGetDevCaps(n, &wic, sizeof(wic));
            if (MMSYSERR_NOERROR != mmr)
            {
               if (-1 != n)
               {
                  wic.vDriverVersion = 0;
                  lstrcpy(wic.szPname, "No");
               }
               else
               {
                  if (0 == nDevs)
                  break;

                  wic.vDriverVersion = 99;
                  lstrcpy(wic.szPname, "-...No");
               }
            }
            uDevType = MMCAPS_DEVTYPE_WAVEIN;
            lParam = MAKELPARAM((WORD)n, (WORD)uDevType);
             //AfxMessageBox(wic.szPname, MB_ICONINFORMATION | MB_OK);
            if(strstr(wic.szPname,"USB EMP Audio Device")) //USB VideoBus II, Audio
            {
				//AfxMessageBox("USB Audio Device", MB_ICONINFORMATION | MB_OK);
               /* if(wic.dwFormats&WAVE_FORMAT_1M08)AfxMessageBox("1M08", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_1M16)AfxMessageBox("1M16", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_1S08)AfxMessageBox("1S08", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_1S16)AfxMessageBox("1S16", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_2M08)AfxMessageBox("2M08", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_2M16)AfxMessageBox("2M16", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_2S08)AfxMessageBox("2S08", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_2S16)AfxMessageBox("2S16", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_4M08)AfxMessageBox("4M08", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_4M16)AfxMessageBox("4M16", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_4S08)AfxMessageBox("4S08", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&WAVE_FORMAT_4S16)AfxMessageBox("4S16", MB_ICONINFORMATION | MB_OK);
                if(wic.dwFormats&!WAVE_FORMAT_4S16&!WAVE_FORMAT_4S16&!WAVE_FORMAT_4S08&!WAVE_FORMAT_4M16&!WAVE_FORMAT_4M08&!WAVE_FORMAT_2S16
                  &!WAVE_FORMAT_2S08&!WAVE_FORMAT_2M16&!WAVE_FORMAT_2M08&!WAVE_FORMAT_1S16&!WAVE_FORMAT_1S08
                  &!WAVE_FORMAT_1M16&!WAVE_FORMAT_1M08)AfxMessageBox("+MORE", MB_ICONINFORMATION | MB_OK);
               */
               // AfxMessageBox("USB VideoBus II, Audio", MB_ICONINFORMATION | MB_OK);
               wfx.cbSize=NULL; //ignored in WAVE_FORMAT_PCM
               wfx.wFormatTag = WAVE_FORMAT_PCM;
               wfx.nChannels=2;
               wfx.nSamplesPerSec=22050; //16000; 
               wfx.wBitsPerSample=16;
               wfx.nBlockAlign=4;
               wfx.nAvgBytesPerSec=wfx.nBlockAlign*wfx.nSamplesPerSec; 

               mmr=waveInOpen( &hwi,n,&wfx,NULL,NULL,CALLBACK_NULL | WAVE_FORMAT_DIRECT );
               /*
               char MsgBuf[255];
               sprintf(MsgBuf,"waveInOpen mmr=%d",(int)mmr);
               AfxMessageBox( (LPCTSTR)MsgBuf,  MB_OK | MB_ICONINFORMATION );*/

               if(mmr==MMSYSERR_ALLOCATED)AfxMessageBox("waveInOpen Specified resource is already allocated.",MB_ICONINFORMATION | MB_OK);
               if(mmr==MMSYSERR_BADDEVICEID)AfxMessageBox("waveInOpen Specified device identifier is out of range.",MB_ICONINFORMATION | MB_OK);
               if(mmr==MMSYSERR_NODRIVER)AfxMessageBox("waveInOpen No device driver is present.",MB_ICONINFORMATION | MB_OK);
               if(mmr==MMSYSERR_NOMEM)AfxMessageBox("waveInOpen Unable to allocate or lock memory.",MB_ICONINFORMATION | MB_OK);
               if(mmr==WAVERR_BADFORMAT)AfxMessageBox("waveInOpen Attempted to open with an unsupported waveform-audio format.",MB_ICONINFORMATION | MB_OK);
               if(mmr==MMSYSERR_INVALPARAM)AfxMessageBox("waveInOpen Invalid parameter passed",MB_ICONINFORMATION | MB_OK);
  
               if(mmr==MMSYSERR_NOERROR) //A
               {
                  //AfxMessageBox("waveInOpen OK",MB_ICONINFORMATION | MB_OK);
                  for(whbuffer=0;whbuffer<MAXWAVCNT && mmr==MMSYSERR_NOERROR;whbuffer++)
                  {
              
                     wavebuffer[whbuffer] = (char *) GlobalLock(GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,
                        cbwh + MAXWAV+1));      

                     wh[whbuffer].dwBufferLength=MAXWAV;
                     wh[whbuffer].lpData=wavebuffer[whbuffer];
                     wh[whbuffer].dwFlags=0;
                     wh[whbuffer].dwBytesRecorded=0;
                     wh[whbuffer].dwUser=0;
                     wh[whbuffer].dwLoops=0;

                     mmr=waveInPrepareHeader(hwi,&wh[whbuffer],cbwh);
               
                  }
                  if(mmr!=MMSYSERR_NOERROR)AfxMessageBox("PrepareHeader Problem", MB_ICONINFORMATION | MB_OK);
                  if(mmr==MMSYSERR_NOERROR) //B
                  {
                     //AfxMessageBox("waveInPrepareHeader OK", MB_ICONINFORMATION | MB_OK);
                     for(whbuffer=0;whbuffer<MAXWAVCNT && mmr==MMSYSERR_NOERROR;whbuffer++)
                     {
                        mmr= waveInAddBuffer(
                           hwi,    
                           &wh[whbuffer],  
                           cbwh       
                           );
                     }
                     if(mmr!=MMSYSERR_NOERROR)AfxMessageBox("AddBuffer Problem", MB_ICONINFORMATION | MB_OK);
         
                     if(mmr==MMSYSERR_NOERROR) //C
                     {
                        mmr=waveInStart( hwi );      // the wavIn device will have a delay that lasts until the middle of wh3.
                        if(mmr==MMSYSERR_NOERROR) //D
                        {
						   //AfxMessageBox("waveInStart OK", MB_ICONINFORMATION | MB_OK);
                           if(testout){if(fclose(testout))AfxMessageBox("fclose error", MB_ICONINFORMATION | MB_OK);Sleep(10);}
                           if(PARFlecksValue.bTESTOUT&&bFilesave)
                              if((testout=fopen( "testout.wav", "wb" ))==NULL)AfxMessageBox("FileOpen error for testout.wav", MB_ICONINFORMATION | MB_OK);
                           strcpy(MsgBuf,"RIFF");
                           MsgBuf[4]=(char)((MAXWAV*1+36)&0x00ff); // size lsb
                           MsgBuf[5]=(char)((MAXWAV*1+36)>>8&0x00ff);
                           MsgBuf[6]=(char)((MAXWAV*1+36)>>16&0x00ff);
                           MsgBuf[7]=(char)((MAXWAV*1+36)>>24&0x00ff);       // size msb (amount of data +36) 83700+36
                           strcpy(&MsgBuf[8],"WAVEfmt ");
                           MsgBuf[16]=(char)16;
                           MsgBuf[17]=(char)0;
                           MsgBuf[18]=(char)0;
                           MsgBuf[19]=(char)0;
                           MsgBuf[20]=(char)1;
                           MsgBuf[21]=(char)0;
                           MsgBuf[22]=(char)2; //2
                           MsgBuf[23]=(char)0;
                           MsgBuf[24]=(char)((wfx.nSamplesPerSec)&0x00ff);//0x40; // speed lsb
                           MsgBuf[25]=(char)((wfx.nSamplesPerSec>>8)&0x00ff);//0x1f; // speed msb (8000)
                           MsgBuf[26]=(char)((wfx.nSamplesPerSec>>16)&0x00ff);//0;
                           MsgBuf[27]=(char)0;
                           MsgBuf[28]=(char)(wfx.nAvgBytesPerSec&0x00ff);//0x00; //Bytes per second lsb
                           MsgBuf[29]=(char)((wfx.nAvgBytesPerSec>>8)&0x00ff);//0x7d; 
                           MsgBuf[30]=(char)((wfx.nAvgBytesPerSec>>16)&0x00ff);//0;
                           MsgBuf[31]=(char)0;
                           MsgBuf[32]=(char)4; //4
                           MsgBuf[33]=(char)0;
                           MsgBuf[34]=(char)16;
                           MsgBuf[35]=(char)0;
                           MsgBuf[36]=(char)0x64; //d
                           MsgBuf[37]=(char)0x61; //a
                           MsgBuf[38]=(char)0x74; //t
                           MsgBuf[39]=(char)0x61; //a
                           MsgBuf[40]=(char)((MAXWAV*1)&0x00ff);   // size lsb
                           MsgBuf[41]=(char)((MAXWAV*1)>>8&0x00ff);
                           MsgBuf[42]=(char)((MAXWAV*1)>>16&0x00ff);
                           MsgBuf[43]=(char)((MAXWAV*1)>>24&0x00ff);    // size msb (amount of data +0)
                           if(testout)fwrite( (const void *)MsgBuf, sizeof( char ), 44, testout );

   
                           for(whbuffer=0;whbuffer<MAXWAVCNT;whbuffer++)
                           {
                              if(mmr==MMSYSERR_NOERROR && PARFlecksValue.measure) //PARFlecksValue.measure tells us if we want to continue measuring PAR and sunflecks
							  {
							     // AfxMessageBox("filling buffer", MB_ICONINFORMATION | MB_OK);
                                 ucnt=0;
                                 bNoValue=FALSE;
                                 while(!(wh[whbuffer].dwFlags & WHDR_DONE) && (ucnt<100)){ucnt++;Sleep(100);}
							      //AfxMessageBox("Done filling buffer", MB_ICONINFORMATION | MB_OK);
                                  //  sprintf(MsgBuf," 390 MAX timer ucnt %u",ucnt);
                                  //  AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
                                  //if(testout)ucnt=fwrite( (const void *)wavebuffer[whbuffer], sizeof( char ),  MAXWAV, testout );
                                  //  sprintf(MsgBuf,"Bytes written %u",ucnt);
                                  //  AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
                              
   
                                 //PARFlecksValue.bTESTOUT=FALSE;  //if(whbuffer==3)
                                 if(!(wh[whbuffer].dwFlags & WHDR_DONE))
                                 {
                                    AfxMessageBox("Wave did not fill buffers.", MB_ICONINFORMATION | MB_OK);
								    //Sleep(4000);
                                    if(testout)ucnt=fwrite( (const void *)wavebuffer[whbuffer], sizeof( char ),  MAXWAV, testout );
                                    if(testout)if(fclose(testout))AfxMessageBox("fclose error", MB_ICONINFORMATION | MB_OK);
                                    testout=NULL;
								    waveInStop(hwi);
                                    bNoValue=TRUE;
                                 }
                                 if(!bNoValue)
                                 {
                                    //AfxMessageBox("!bNoValue", MB_ICONINFORMATION | MB_OK);
                                    uval=0;
                                    ubcnt=0;
   
                                    for(uval=142;(uval<MAXWAV-MAXAVG*100+202+113)&&((*(wavebuffer[whbuffer]+uval))<5);uval+=4)//used to start at 140, changed to 142 to measure PAR instead of sunflecks
                                    {
                               //     if(uval>20000)
                               //     {
                               //        sprintf(MsgBuf,"Not to 20 at 20000 uval %u",uval);
                               //        AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
                               //     }
                                    }
								
                                    if(uval>=MAXWAV-MAXAVG*100+202+113)
								    {
                                       if(testout)ucnt=fwrite( (const void *)wavebuffer[whbuffer], sizeof( char ),  MAXWAV, testout );
									   numwritten=numwritten+ucnt;
                                       if(whbuffer==MAXWAVCNT-1)
									   {
									      if(testout)if(fclose(testout))AfxMessageBox("fclose error", MB_ICONINFORMATION | MB_OK);
                                          if(testout)sprintf(MsgBuf,"Written %u, whbuffer %u",numwritten,whbuffer);
                                          if(testout)AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
										  numwritten=0;
										  whbuffer=MAXWAVCNT;
                                          testout=NULL;
										  bFilesave=FALSE;
									      PARFlecksValue.count++; //terminate measurement with no results
									   }
                                       //if(testout)sprintf(MsgBuf,"Written %u, whbuffer %u",numwritten,whbuffer);
                                       //if(testout)AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
								    }
								    else
                                    {
                                       if(testout)ucnt=fwrite( (const void *)wavebuffer[whbuffer], sizeof( char ),  MAXWAV, testout );
                                       //if(testout)sprintf(MsgBuf,"Bytes written %u, Buffer %u",ucnt,whbuffer);
                                       //if(testout)AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
                                       uparcnt=0;
                                       PARFlecksValue.Flecks=0.0;
                                       PARFlecksValue.PAR=0.0;
                                       for(un=0;un<MAXAVG;un++) /* we will average some readings */
                                       {
                                          uinterval=0; // 210 offset from uval to starting to measure and about 1616 long
                                          upar[un]=0;
                                          ipar[un]=0;
                                          uFlecks[un]=0;
                                          iFlecks[un]=0;
                                          if(ubcnt==0)
                                          {
                                             ucnt=uval+2+202+100*un; // 0 is msb of left, 1 is lsb of left, 2 is msb of right, 3 is lsb of right...added 2 to keep par sunflecks in right order after changing uval
                                             //if(testout)sprintf(MsgBuf,"ucnt %u",ucnt);
                                             //if(testout)AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
                                             if(ucnt<MAXWAV-113)
                                             {
                                                for(uinterval=1;uinterval<113;uinterval+=4) //28 readings with about 10 per cycle
                                                {
                                                  c1=(*(wavebuffer[whbuffer]+ucnt+uinterval));
                                                  c2=(*(wavebuffer[whbuffer]+ucnt-1+uinterval));
                                                  itmp=(unsigned int)c1*256+(unsigned int)c2;
                                                  if(itmp>32767)itmp=itmp-65536;
                                                  if(itmp>0&&itmp>upar[un])upar[un]=itmp;
                                                  if(itmp<0&&itmp<ipar[un])ipar[un]=itmp;
                                                }
                                                for(uinterval=3;uinterval<113;uinterval+=4)
                                                {
                                                  c1=(*(wavebuffer[whbuffer]+ucnt+uinterval));
                                                  c2=(*(wavebuffer[whbuffer]+ucnt-1+uinterval));
                                                  itmp=(unsigned int)c1*256+(unsigned int)c2;
                                                  if(itmp>32767)itmp=itmp-65536;
                                                  if(itmp<0&&itmp<iFlecks[un])iFlecks[un]=itmp;
                                                  if(itmp>0&&itmp>uFlecks[un])uFlecks[un]=itmp;
                                                }
                                             }
                                             else
                                             {
                                                upar[un]=0;
                                                uFlecks[un]=0;
                                             }
                              //             sprintf(MsgBuf,"upar %u,  uFlecks %u",upar[un], uFlecks[un]);
                              //             AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
      
                                          }
                                          PARFlecksValue.Flecks+=::Flecksgain*ci_config_geometry->Flecksspancal*(((double)uFlecks[un]-(double)iFlecks[un])+(double)ci_config_geometry->Fleckszerocal);
                                          PARFlecksValue.PAR=PARFlecksValue.PAR+::PARgain*ci_config_geometry->PARspancal*(((double)upar[un]-(double)ipar[un])+ci_config_geometry->PARzerocal);
                         //               sprintf(MsgBuf,"Flecksgain %g, spancal %g, uFlecks %u", ::Flecksgain, ci_config_geometry->Flecksspancal, uFlecks[un]);
                        //                AfxMessageBox(MsgBuf, MB_ICONINFORMATION | MB_OK);
         
                                       } // for(un=0;un<24;un++)
                                       if (PARFlecksValue.PAR<0.0)PARFlecksValue.PAR=0.0;
                                       if(whbuffer==0)mmr=100; // lets stop this recording stuff.
                                       if((PARFlecksValue.measure>0) && (bNoValue==FALSE))
                                       {
                                          ::PAR=PARFlecksValue.PAR;
                                          ::Flecks=PARFlecksValue.Flecks;
                                          if(::Flecks>100.0)::Flecks=100.0;
                                          if(::PAR<0.0)::PAR=0.0;
                                          if(::Flecks<0.0)::Flecks=0.0;
                                          PARFlecksValue.count++;
                              //         PARFlecksValue.measure=0;
                                          CDocument* pDoc = mainFrame->GetActiveDocument();
                                          if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)))
                                          {
                                             ((CDibDoc*) pDoc)->UpdateAllViews(NULL);
                                          }       
                                       }
                                       whbuffer=MAXWAVCNT;
                                    } //if(uval<MAXWAV-MAXAVG*100+202+113)
                                 } //if(!bNoValue)
                              }//if(mmr==MMSYSERR_NOERROR && PARFlecksValue.measure>0)
                           }// for whbuffer
                           mmr=waveInReset(hwi);
                        } // if(mmr==MMSYSERR_NOERROR) //D
						      else
							   AfxMessageBox("waveInStart Problem", MB_ICONINFORMATION | MB_OK);
                     } // if(mmr==MMSYSERR_NOERROR) //C
                     Sleep(10);
                     if(testout)if(fclose(testout))AfxMessageBox("fclose error", MB_ICONINFORMATION | MB_OK);
					 numwritten=0;
                     testout=NULL;
                     Sleep(10);
                  } // if(mmr==MMSYSERR_NOERROR) //B
                  for(whbuffer=0; whbuffer<MAXWAVCNT; whbuffer++)
                  {
                     mmr=waveInUnprepareHeader(hwi,&wh[whbuffer],cbwh);
                     if(mmr==MMSYSERR_INVALHANDLE)AfxMessageBox("Unprepare failed: Specified device handle is invalid.", MB_ICONINFORMATION | MB_OK);
                     if(mmr==MMSYSERR_NODRIVER)AfxMessageBox("Unprepare failed: No device driver is present.", MB_ICONINFORMATION | MB_OK);
                     if(mmr==MMSYSERR_NOMEM)AfxMessageBox("Unprepare failed: Unable to allocate or lock memory.", MB_ICONINFORMATION | MB_OK);
                     if(mmr==WAVERR_STILLPLAYING){AfxMessageBox("Unprepare failed: The buffer pointed to by the pwh parameter is still in the queue.", MB_ICONINFORMATION | MB_OK);}
                  }  // for(whbuffer=0; whbuffer<MAXWAVCNT; whbuffer++)
               } // if(mmr==MMSYSERR_NOERROR) //A
               mmr=waveInReset(hwi);
               mmr=waveInClose(hwi);
               if(mmr!=MMSYSERR_NOERROR) AfxMessageBox("Closed wav with incident", MB_ICONINFORMATION | MB_OK);
			   Sleep(10);
               for(whbuffer=0; whbuffer<MAXWAVCNT; whbuffer++)
               {
                  mmr=GlobalUnlock(GlobalHandle(wavebuffer[whbuffer]));
                  if(mmr!=MMSYSERR_NOERROR)AfxMessageBox("Unlock failed", MB_ICONINFORMATION | MB_OK);
                  if(NULL!=GlobalFree(GlobalHandle(wavebuffer[whbuffer]))) AfxMessageBox("Free failed", MB_ICONINFORMATION | MB_OK);
               }

            } // if(strstr(wic.szPname,"USB VideoBus II, Audio"))
         } // for (n = -1; n < nDevs; n++)
      } //if(PARFlecksValue.measure>0)
      else
         Sleep(300);
   } //while (1)
   return(uResult);
}
/******************************************************************************************************************/










////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg) 
{
	/*** old code, used CTwain's functions
	return TwainMessageHook(pMsg) ||
		   CFrameWnd::PreTranslateMessage(pMsg);
		   */
	return TWAIN_MessageHook(pMsg) ||
		CFrameWnd::PreTranslateMessage(pMsg);
}

void CMainFrame::OnUpdateAcquire(CCmdUI* pCmdUI) 
{
	// Only allow Acquire if source mgr was brought
	// up successfully, and there is no acquisition
	// already going on.
	/*** old code, used CTwain's functions
	pCmdUI->Enable(State() == SOURCE_MANAGER_OPEN);
	*/
	//pCmdUI->Enable(TWAIN_State() == TWAIN_SM_OPEN);
	pCmdUI->Enable(TWAIN_IsAvailable());
// AfxMessageBox("OnUpdateAcquire",  MB_OK);
}

void CMainFrame::OnAcquire() 
{
	int count=PARFlecksValue.count;
	/*** old code, used CTwain's functions
	BeginAcquire();
	*/
	PARFlecksValue.measure=1;

	//TWAIN_AcquireToClipboard(m_hWnd, TWAIN_ANYTYPE);
	HGLOBAL hdib = TWAIN_AcquireNative(m_hWnd, TWAIN_ANYTYPE);
	if (hdib) {
		DibReceived(hdib);
	} //if hdib
    while(PARFlecksValue.count==count)Sleep(100);//Sleep(100);
	PARFlecksValue.measure=0;

}



void CMainFrame::OnSunflecks() //This gets executed when sunflecks button pushed
{
    int count=PARFlecksValue.count;
  //  PARProc();
	PARFlecksValue.measure=1;
	

	
 	 if (!TWAIN_LoadSourceManager()) {
		AfxMessageBox("TWAIN LoadSourceManager error", MB_ICONINFORMATION | MB_OK);
	} else if (!TWAIN_OpenSourceManager(m_hWnd)) {
		AfxMessageBox("TWAIN OpenSourceManager error", MB_ICONINFORMATION | MB_OK);
    } else if (!TWAIN_OpenDefaultSource()) {
		AfxMessageBox("TWAIN default Data Source error", MB_ICONINFORMATION | MB_OK);
	} else if (!TWAIN_NegotiatePixelTypes(TWAIN_ANYTYPE)) {
		AfxMessageBox("TWAIN PixelType error", MB_ICONINFORMATION | MB_OK);
	} else if (!TWAIN_EnableSource(m_hWnd)) {
		AfxMessageBox("TWAIN Failed to enable Data Soruce", MB_ICONINFORMATION | MB_OK);
	}
	Sleep(10);

	// shut everything down in the right sequence
	// these routines do nothing if the corresponding 'open' failed
	TWAIN_DisableSource();
	TWAIN_CloseSource();	
    TWAIN_CloseSourceManager(m_hWnd);
    TWAIN_UnloadSourceManager();



    while(PARFlecksValue.count==count)Sleep(100);
	PARFlecksValue.measure=0;
	
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		CDibView* pView = (CDibView*) GetActiveView();
		pView->SetImageAdjustment(FALSE);
        ((CDibDoc*) pDoc)->ShowResultSF();
	}

}



void CMainFrame::OnUpdateSelectSource(CCmdUI* pCmdUI) 
{
	/*** old code, used CTwain's functions
	pCmdUI->Enable(State() == SOURCE_MANAGER_OPEN);
	*/
	//pCmdUI->Enable(TWAIN_State() == TWAIN_SM_OPEN);
	pCmdUI->Enable(TWAIN_IsAvailable());

}

void CMainFrame::OnSelectSource() 
{
	/*** old code, used CTwain's functions
	SelectSource();
	*/
	TWAIN_SelectImageSource(m_hWnd);
	//AfxMessageBox("TWAIN SelectImageSource here!!", MB_ICONINFORMATION | MB_OK);


// #############################################################################################################
//%%%%%%%%%%%%%%%%%%%%%%%%5%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%





//	  HDEVINFO hDevInfo=INVALID_HANDLE_VALUE;

/*
	 SP_DEVINFO_DATA DeviceInfoData;
	 DWORD i;
	 SP_DEVICE_INTERFACE_DATA  DeviceInterfaceData;
	 SP_DEVICE_INTERFACE_DETAIL_DATA  DeviceInterfaceDetailData;

	 // Create a HDEVINFO for Audio in present devices.
	 hDevInfo = SetupDiGetClassDevs((LPGUID) &GUID_BELKINAUDIO, NULL, NULL, 
										DIGCF_PRESENT | DIGCF_PROFILE);
	   
	 if (hDevInfo == INVALID_HANDLE_VALUE)
	 {
		   // Insert error handling here.
		AfxMessageBox("Invalid_handle_value in setupdigetclassdevs", MB_ICONINFORMATION | MB_OK);
	 }
	 else
	 {

		SP_DEVICE_INTERFACE_DATA  DeviceInterfaceData;
		DeviceInterfaceData.cbSize=sizeof(DeviceInterfaceData);
		DWORD i;

		for(i=0;SetupDiEnumDeviceInterfaces(
				   hDevInfo,
				   NULL, //&DeviceInfoData,
				   (LPGUID) &GUID_BELKINAUDIO,
				   i,
				   &DeviceInterfaceData
				  );i++)
	   {
		   DWORD DataT;
		   LPTSTR buffer = NULL;
		   DWORD buffersize = 0;
		   
		   // 
		   // Call function with null to begin with, 
		   // then use the returned buffer size 
		   // to Alloc the buffer. Keep calling until
		   // success or an unknown failure.
		   // 
		AfxMessageBox("SetupDiGetDeviceRegistryProperty", MB_ICONINFORMATION | MB_OK);
		   while (!SetupDiGetDeviceRegistryProperty(
			   hDevInfo,
			   &DeviceInfoData,
			   SPDRP_DEVICEDESC,
			   &DataT,
			   (PBYTE)buffer,
			   buffersize,
			   &buffersize))
		   {
			   if (GetLastError() == 
				   ERROR_INSUFFICIENT_BUFFER)
			   {
					//Change the buffer size.
				   if (buffer) LocalFree(buffer);
				   buffer =(char *) LocalAlloc(LPTR,buffersize);
			   }
			   else
			   {
				   // Insert error handling here.
					AfxMessageBox("SetupDiGetDeviceRegistryProperty screw up", MB_ICONINFORMATION | MB_OK);

				   break;
			   }
		   }  //end of while (!SetupDiGetDeviceRegistryProperty
		} //end of for(i=0;SetupDiEnumDeviceInterfaces
	 } //end of if (hDevInfo == INVALID_HANDLE_VALUE) else...
*/
/*
		   if(!strcmp("Belkin USB VideoBus II, Audio",buffer))
		   {
				AfxMessageBox(buffer, MB_ICONINFORMATION | MB_OK);

				DWORD  DeviceInterfaceDetailDataSize=0;
				DWORD  RequiredSize;


				SetupDiGetDeviceInterfaceDetail(
					 hDevInfo,
					 &DeviceInterfaceData,
					 &DeviceInterfaceDetailData,
					 DeviceInterfaceDetailDataSize,
					 &RequiredSize,
					 &DeviceInfoData
					);

*/


/*


	   SP_DEVINFO_DATA DeviceInfoData;
	   DWORD i;

	   // Create a HDEVINFO for Audio in present devices.
	   hDevInfo = SetupDiGetClassDevs((LPGUID) &GUID_BELKINAUDIO, NULL, NULL, 
										DIGCF_PRESENT | DIGCF_PROFILE );
	   
	   if (hDevInfo == INVALID_HANDLE_VALUE)
	   {
		   // Insert error handling here.
			AfxMessageBox("Invalid_handle_value in setupdigetclassdevs", MB_ICONINFORMATION | MB_OK);
	   }
	   else
	   {

	SP_DEVICE_INTERFACE_DATA  DeviceInterfaceData;
	//SP_INTERFACE_DEVICE_DATA ifdata;
	DeviceInterfaceData.cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);

	   // Enumerate through all devices in Set.
	   
	   DeviceInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
	   for (DWORD i=0;SetupDiEnumDeviceInfo(hDevInfo,i,
		   &DeviceInfoData);i++)
	   {
		   DWORD DataT;
		   LPTSTR buffer = NULL;
		   DWORD buffersize = 0;
		   
		   // 
		   // Call function with null to begin with, 
		   // then use the returned buffer size 
		   // to Alloc the buffer. Keep calling until
		   // success or an unknown failure.
		   // 
		   while (!SetupDiGetDeviceRegistryProperty(
			   hDevInfo,
			   &DeviceInfoData,
			   SPDRP_DEVICEDESC,
			   &DataT,
			   (PBYTE)buffer,
			   buffersize,
			   &buffersize))
		   {
			   if (GetLastError() == 
				   ERROR_INSUFFICIENT_BUFFER)
			   {
					//Change the buffer size.
				   if (buffer) LocalFree(buffer);
				   buffer =(char *) LocalAlloc(LPTR,buffersize);
			   }
			   else
			   {
				   // Insert error handling here.
					AfxMessageBox("SetupDiGetDeviceRegistryProperty screw up", MB_ICONINFORMATION | MB_OK);

				   break;
			   }
		   }
		   if(!strcmp("Belkin USB VideoBus II, Audio",buffer))
		   {
				AfxMessageBox(buffer, MB_ICONINFORMATION | MB_OK);
				if(i==0)AfxMessageBox("i==0", MB_ICONINFORMATION | MB_OK);
				if(i==1)AfxMessageBox("i==1", MB_ICONINFORMATION | MB_OK);
				if(i==2)AfxMessageBox("i==2", MB_ICONINFORMATION | MB_OK);
				if(i==3)AfxMessageBox("i==3", MB_ICONINFORMATION | MB_OK);
				if(i==4)AfxMessageBox("i==4", MB_ICONINFORMATION | MB_OK);
				if(i==5)AfxMessageBox("i==5", MB_ICONINFORMATION | MB_OK);
				if(i==6)AfxMessageBox("i==6", MB_ICONINFORMATION | MB_OK);
				if(i==7)AfxMessageBox("i==7", MB_ICONINFORMATION | MB_OK);
				if(i==8)AfxMessageBox("i==8", MB_ICONINFORMATION | MB_OK);
				if(i==9)AfxMessageBox("i==9", MB_ICONINFORMATION | MB_OK);
				if(i==10)AfxMessageBox("i==10", MB_ICONINFORMATION | MB_OK);
				if(i==11)AfxMessageBox("i==11", MB_ICONINFORMATION | MB_OK);
				if(i==12)AfxMessageBox("i==12", MB_ICONINFORMATION | MB_OK);

				
				AfxMessageBox("Going to EnumDeviceInterfaces", MB_ICONINFORMATION | MB_OK);
				
				
				if(!SetupDiEnumDeviceInterfaces(
				   hDevInfo,
				   NULL,//&DeviceInfoData,
				   (LPGUID) &GUID_BELKINAUDIO,
				   0,
				   &DeviceInterfaceData
				  ))
				{
LPVOID lpMsgBuf;
FormatMessage( 
	FORMAT_MESSAGE_ALLOCATE_BUFFER | 
	FORMAT_MESSAGE_FROM_SYSTEM | 
	FORMAT_MESSAGE_IGNORE_INSERTS,
	NULL,
	GetLastError(),
	MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
	(LPTSTR) &lpMsgBuf,
	0,
	NULL 
);
// Process any inserts in lpMsgBuf.
// ...
// Display the string.
AfxMessageBox( (LPCTSTR)lpMsgBuf, MB_OK | MB_ICONINFORMATION );
// Free the buffer.
LocalFree( lpMsgBuf );
				}
		   
	DWORD needed=0;
	SetupDiGetInterfaceDeviceDetail(hDevInfo, &DeviceInterfaceData, NULL, 0, &needed, NULL);
	if(!needed) 		AfxMessageBox("Nothing needed!!@", MB_ICONINFORMATION | MB_OK);

	PSP_INTERFACE_DEVICE_DETAIL_DATA detail = 
		(PSP_INTERFACE_DEVICE_DETAIL_DATA) malloc(needed);
	if (!detail)
		{
	   //	AfxMessageBox("Interface detail memory problem.", MB_ICONINFORMATION | MB_OK);
			break;
		}
		else
		{
		  detail->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
		  if (!SetupDiGetInterfaceDeviceDetail(hDevInfo, &DeviceInterfaceData, detail, needed,
										 NULL, NULL))
		  {
			AfxMessageBox("Interface detail problem.", MB_ICONINFORMATION | MB_OK);
			break;
		  }
			else 
			{

			  char name[MAX_PATH];
			  strncpy(name, detail->DevicePath, sizeof(name));
	   AfxMessageBox(name, MB_ICONINFORMATION | MB_OK);

			  HANDLE hfile = CreateFile(name, GENERIC_READ, 0, NULL, 
							  OPEN_EXISTING, 0, NULL);
			  if (hfile == INVALID_HANDLE_VALUE)
			  {
				 AfxMessageBox("Opening device file problem.", MB_ICONINFORMATION | MB_OK);
				 break;
			  }
				else
				{
			
					CloseHandle(hfile);
				} //end of	   if (hfile == INVALID_HANDLE_VALUE) ... else
				free((PVOID) detail);
			} //end of	   if (!SetupDiGetInterfaceDeviceDetail(hDevInfo, &ifdata, detail, needed, ... else

		} //end of	  if (!detail) else
		   
		   
	   
		   
		   
		   
		   
	   
		   
		   
		   
		   } //end of if(!strcmp("Belkin...
	   //	printf("Result:[%s]\n",buffer);
		   
		   if (buffer) LocalFree(buffer);
	   }
	*/
/*
LPVOID lpMsgBuf;
FormatMessage( 
	FORMAT_MESSAGE_ALLOCATE_BUFFER | 
	FORMAT_MESSAGE_FROM_SYSTEM | 
	FORMAT_MESSAGE_IGNORE_INSERTS,
	NULL,
	GetLastError(),
	MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
	(LPTSTR) &lpMsgBuf,
	0,
	NULL 
);
// Process any inserts in lpMsgBuf.
// ...
// Display the string.
AfxMessageBox( (LPCTSTR)lpMsgBuf, MB_OK | MB_ICONINFORMATION );
// Free the buffer.
LocalFree( lpMsgBuf );
	   
	 
	   if ( GetLastError()!=NO_ERROR &&
			GetLastError()!=ERROR_NO_MORE_ITEMS )
	   {
		   // Insert error handling here.
					AfxMessageBox("something screwed up in error handling", MB_ICONINFORMATION | MB_OK);
	   }
	
	
	
	//if (!SetupDiEnumInterfaceDevice(hDevInfo, NULL, (LPGUID) &GUID_BELKINAUDIO,
	 // 							  0, &ifdata))
	   // {
		//	AfxMessageBox("SetupDiEnumInterfaceDevice problem.", MB_ICONINFORMATION | MB_OK);


//LPVOID lpMsgBuf;
//FormatMessage( 
	//FORMAT_MESSAGE_ALLOCATE_BUFFER | 
	//FORMAT_MESSAGE_FROM_SYSTEM | 
	//FORMAT_MESSAGE_IGNORE_INSERTS,
	//NULL,
	//GetLastError(),
	//MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
	//(LPTSTR) &lpMsgBuf,
	//0,
	//NULL 
//);
// Process any inserts in lpMsgBuf.
// ...
// Display the string.
//AfxMessageBox( (LPCTSTR)lpMsgBuf,  MB_OK | MB_ICONINFORMATION );
// Free the buffer.
//LocalFree( lpMsgBuf );



	//	  }
		else
		{
  */

/*	  DWORD needed;
	SetupDiGetInterfaceDeviceDetail(hDevInfo, &ifdata, NULL, 0, &needed, NULL);
	PSP_INTERFACE_DEVICE_DETAIL_DATA detail = 
		(PSP_INTERFACE_DEVICE_DETAIL_DATA) malloc(needed);
	if (!detail)
		{
			AfxMessageBox("Interface detail memory problem.", MB_ICONINFORMATION | MB_OK);
		}
		else
		{
	detail->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
	if (!SetupDiGetInterfaceDeviceDetail(hDevInfo, &ifdata, detail, needed,
										 NULL, NULL))
		{
			AfxMessageBox("Interface detail problem.", MB_ICONINFORMATION | MB_OK);
		}
		else 
		{

	char name[MAX_PATH];
	strncpy(name, detail->DevicePath, sizeof(name));

	HANDLE hfile = CreateFile(name, GENERIC_READ, 0, NULL, 
							  OPEN_EXISTING, 0, NULL);
	if (hfile == INVALID_HANDLE_VALUE)
		{
			AfxMessageBox("Opening device file problem.", MB_ICONINFORMATION | MB_OK);
		}
		else
		{


		} //end of	   if (hfile == INVALID_HANDLE_VALUE) ... else
		free((PVOID) detail);
		} //end of	   if (!SetupDiGetInterfaceDeviceDetail(hDevInfo, &ifdata, detail, needed, ... else

		} //end of	  if (!detail) else

	} // end of 	if (!SetupDiEnumInterfaceDevice(info, NULL, (LPGUID) &GUID_BELKINAUDIO, ... else
*/	
	   //  Cleanup
	//	 SetupDiDestroyDeviceInfoList(hDevInfo);
 
/*		
USB_CONFIGURATION_DESCRIPTOR UCD, *pFullUCD;
UsbBuildGetDescriptorRequest(
	pURB, // points to the URB to be filled in
	sizeof(_URB_CONTROL_DESCRIPTOR_REQUEST),
	USB_CONFIGURATION_DESCRIPTOR_TYPE,
	i, // number of configuration descriptor
	0, // this parameter not used for configuration descriptors
	&UCD, // points to a USB_CONFIGURATION_DESCRIPTOR
	NULL,
	sizeof(USB_DEVICE_DESCRIPTOR),
	NULL
);
pFullUCD = ExAllocatePool(NonPagedPool, UCD.wTotalLength);
UsbBuildGetDescriptorRequest(
	pURB, // points to the URB to be filled in
	sizeof(_URB_CONTROL_DESCRIPTOR_REQUEST),
	USB_CONFIGURATION_DESCRIPTOR_TYPE,
	i, // number of configuration descriptor
	0, // this parameter not used for configuration descriptors
	pFullUCD, // points to a USB_CONFIGURATION_DESCRIPTOR
	NULL,
	UCD.wTotalLength,
	NULL
);

*/




}

void CMainFrame::OnDestroy() 
{
	/*** old code, used CTwain's functions
	CloseSourceManager();
	UnloadSourceManager();
	*/
	TWAIN_CloseSourceManager(m_hWnd);
	TWAIN_UnloadSourceManager();
	CFrameWnd::OnDestroy();
}

void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
}

void CMainFrame::OnPaletteChanged(CWnd* pFocusWnd) 
{
	if (pFocusWnd != this) {
		OnQueryNewPalette();
	}
}

BOOL CMainFrame::OnQueryNewPalette() 
{
	BOOL f = FALSE;
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		CDC* pDC = GetDC(); 
		f = ((CDibDoc*)pDoc)->RealizePalette(pDC) > 0;
		ReleaseDC(pDC); 
		if (f) { 
			Invalidate();
		}
	}
	return f;
}

void CMainFrame::OnOptionsSetup() 
{

	setupPS.SetTitle("Setup");

	setupPS.cropCirclePage.radius = ci_config_image->radius;
	setupPS.cropCirclePage.x = ci_config_image->center_x;
	setupPS.cropCirclePage.y = ci_config_image->center_y;
	setupPS.cropCirclePage.blankout_start = ci_config_geometry->blankout1;
	setupPS.cropCirclePage.blankout_end = ci_config_geometry->blankout2;
	
	setupPS.outputPage.m_output_PAR = ci_config_output->bPAR;	
	setupPS.outputPage.m_output_SUNTRACK = ci_config_output->bSUNTRACK; 
	setupPS.outputPage.m_output_k = ci_config_output->bK;
	setupPS.outputPage.m_output_LAI = ci_config_output->bLAI;
	setupPS.outputPage.m_output_LD = ci_config_output->bLD;
	setupPS.outputPage.m_output_MFIA = ci_config_output->bMFIA;
	setupPS.outputPage.m_output_TD = ci_config_output->bTD;
	setupPS.outputPage.m_output_TR = ci_config_output->bTR;

	setupPS.geometryPage.m_AzmuthalDivision = ci_config_geometry->num_of_azmuthal_division;
	setupPS.geometryPage.m_endZenithAngle = ci_config_geometry->ending_zenith_angle;
	setupPS.geometryPage.m_startZenithAngle = ci_config_geometry->starting_zenith_angle;
	setupPS.geometryPage.m_threshHoldLevel = ci_config_geometry->threshhold_level;
	setupPS.geometryPage.m_PARzerocal = ci_config_geometry->PARzerocal;
	setupPS.geometryPage.m_PARspancal = ci_config_geometry->PARspancal;
	setupPS.geometryPage.m_Fleckszerocal = ci_config_geometry->Fleckszerocal;
	setupPS.geometryPage.m_Flecksspancal = ci_config_geometry->Flecksspancal;
	setupPS.geometryPage.m_Latitude = ci_config_geometry->Latitude;
	setupPS.geometryPage.m_month1 = ci_config_geometry->Month1;
	setupPS.geometryPage.m_day1 = ci_config_geometry->Day1;
	setupPS.geometryPage.m_month2 = ci_config_geometry->Month2;
	setupPS.geometryPage.m_day2 = ci_config_geometry->Day2;
	setupPS.geometryPage.m_viewRange = ci_config_geometry->view_range;
	setupPS.geometryPage.m_zenithDivision = ci_config_geometry->num_of_zenith_division;

	if (setupPS.DoModal() == IDOK)
	{
		SendMessage(WM_USERAPPLY);
	}
}
   
void CMainFrame::OnAcquireClipboard() 
{
	// TODO: Add your command handler code here
	
}

void CMainFrame::OnUpdateAcquireClipboard(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	
}

LRESULT CMainFrame::OnUserApply(WPARAM wParam, LPARAM lParam)
{
	TRACE("CMainFrame::OnUserApply--wParam = %x\n", wParam);
	BOOL image_changed = FALSE; //whether need to update the images
	BOOL view_changed = FALSE; //whether need to update the view

	if (ci_config_image->radius != setupPS.cropCirclePage.radius)
	{
		image_changed = TRUE;
		configChanged = TRUE;
		ci_config_image->radius = setupPS.cropCirclePage.radius;
	}
	if (ci_config_image->center_x != setupPS.cropCirclePage.x)
	{
		image_changed = TRUE;
		configChanged = TRUE;
		ci_config_image->center_x = setupPS.cropCirclePage.x;
	}
	if (ci_config_image->center_y != setupPS.cropCirclePage.y)
	{
		image_changed = TRUE;
		configChanged = TRUE;
		ci_config_image->center_y = setupPS.cropCirclePage.y;
	}
	if (ci_config_geometry->blankout1 != setupPS.cropCirclePage.blankout_start)
	{
		image_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->blankout1 = setupPS.cropCirclePage.blankout_start;
	}
	if (ci_config_geometry->blankout2 != setupPS.cropCirclePage.blankout_end)
	{
		image_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->blankout2 = setupPS.cropCirclePage.blankout_end;
	}
	if (ci_config_geometry->blankout2 == ci_config_geometry->blankout1)
		ci_config_geometry->blankout_flag = FALSE;
	else
		ci_config_geometry->blankout_flag = TRUE;

	if (ci_config_output->bK != setupPS.outputPage.m_output_k)
	{
		configChanged = TRUE;
		ci_config_output->bK = setupPS.outputPage.m_output_k;
	}
	if (ci_config_output->bPAR != setupPS.outputPage.m_output_PAR)
	{
		configChanged = TRUE;
		ci_config_output->bPAR = setupPS.outputPage.m_output_PAR;
	}
	if (ci_config_output->bSUNTRACK != setupPS.outputPage.m_output_SUNTRACK)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_output->bSUNTRACK = setupPS.outputPage.m_output_SUNTRACK;
	}
	if (ci_config_output->bLAI != setupPS.outputPage.m_output_LAI)
	{
		configChanged = TRUE;
		ci_config_output->bLAI = setupPS.outputPage.m_output_LAI;
	}
	if (ci_config_output->bLD != setupPS.outputPage.m_output_LD)
	{
		configChanged = TRUE;
		ci_config_output->bLD = setupPS.outputPage.m_output_LD;
	}
	if (ci_config_output->bMFIA != setupPS.outputPage.m_output_MFIA)
	{
		configChanged = TRUE;
		ci_config_output->bMFIA = setupPS.outputPage.m_output_MFIA;
	}
	if (ci_config_output->bTD != setupPS.outputPage.m_output_TD)
	{
		configChanged = TRUE;
		ci_config_output->bTD = setupPS.outputPage.m_output_TD;
	}
	if (ci_config_output->bTR != setupPS.outputPage.m_output_TR)
	{
		configChanged = TRUE;
		ci_config_output->bTR = setupPS.outputPage.m_output_TR;
	}
	if (ci_config_geometry->num_of_azmuthal_division != setupPS.geometryPage.m_AzmuthalDivision)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->num_of_azmuthal_division = setupPS.geometryPage.m_AzmuthalDivision;
	}
	if (ci_config_geometry->ending_zenith_angle != setupPS.geometryPage.m_endZenithAngle)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->ending_zenith_angle = setupPS.geometryPage.m_endZenithAngle;
	}
	if (ci_config_geometry->starting_zenith_angle != setupPS.geometryPage.m_startZenithAngle)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->starting_zenith_angle = setupPS.geometryPage.m_startZenithAngle;
	}
	if (ci_config_geometry->threshhold_level != setupPS.geometryPage.m_threshHoldLevel)
	{
		//image_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->threshhold_level = setupPS.geometryPage.m_threshHoldLevel;

	}
	if (ci_config_geometry->PARzerocal != setupPS.geometryPage.m_PARzerocal)
	{
		configChanged = TRUE;
		ci_config_geometry->PARzerocal = setupPS.geometryPage.m_PARzerocal;
	}
	if (ci_config_geometry->PARspancal != setupPS.geometryPage.m_PARspancal)
	{
		configChanged = TRUE;
		ci_config_geometry->PARspancal = setupPS.geometryPage.m_PARspancal;
	}
	if (ci_config_geometry->Fleckszerocal != setupPS.geometryPage.m_Fleckszerocal)
	{
		configChanged = TRUE;
		ci_config_geometry->Fleckszerocal = setupPS.geometryPage.m_Fleckszerocal;
	}
	if (ci_config_geometry->Flecksspancal != setupPS.geometryPage.m_Flecksspancal)
	{
		configChanged = TRUE;
		ci_config_geometry->Flecksspancal = setupPS.geometryPage.m_Flecksspancal;
	}
	if (ci_config_geometry->Latitude != setupPS.geometryPage.m_Latitude)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->Latitude = setupPS.geometryPage.m_Latitude;
	}
	if (ci_config_geometry->Month1 != setupPS.geometryPage.m_month1)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->Month1 = setupPS.geometryPage.m_month1;
	}
	if (ci_config_geometry->Day1 != setupPS.geometryPage.m_day1)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->Day1 = setupPS.geometryPage.m_day1;
	}
	if (ci_config_geometry->Month2 != setupPS.geometryPage.m_month2)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->Month2 = setupPS.geometryPage.m_month2;
	}
	if (ci_config_geometry->Day2 != setupPS.geometryPage.m_day2)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->Day2 = setupPS.geometryPage.m_day2;
	}
	if (ci_config_geometry->view_range != setupPS.geometryPage.m_viewRange)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->view_range = setupPS.geometryPage.m_viewRange;
	}
	if (ci_config_geometry->num_of_zenith_division != setupPS.geometryPage.m_zenithDivision)
	{
		view_changed = TRUE;
		configChanged = TRUE;
		ci_config_geometry->num_of_zenith_division = setupPS.geometryPage.m_zenithDivision;
	}

	if (image_changed)
	{
		CDocument* pDoc = GetActiveDocument();
		if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
			((CDibDoc*) pDoc)->UpdateImages();
			((CDibDoc*) pDoc)->UpdateAllViews(NULL);
		}
	}
	if (view_changed)
	{
		CDocument* pDoc = GetActiveDocument();
		if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
			((CDibDoc*) pDoc)->UpdateAllViews(NULL);
		}
	}
	return 0;
}


double ci_cos(double x)
{
	return cos(x);
}

double ci_sin(double x)
{
	return sin(x);
}

double ci_sqrt(double x)
{
	return sqrt(x);
}

double ci_pow(double z, double x)
{
	return pow(z,x);
}

double ci_log(double x)
{
	return log(x);
}

double ci_exp(double x)
{
	return exp(x);
}

double ci_tan(double x)
{
	return tan(x);
}

double ci_atan(double x)
{
	return atan(x);
}

void CMainFrame::OnImageMeasure() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		CDibView* pView = (CDibView*) GetActiveView();
		pView->SetImageAdjustment(FALSE);
		((CDibDoc*) pDoc)->Measure();
		//((CDibDoc*) pDoc)->ShowResult();
	}
}

void CMainFrame::OnUpdateImageMeasure(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		pCmdUI->Enable(((CDibDoc*) pDoc)->IsMeasurable());
	}
	else
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnImageCropsetup() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		((CDibDoc*) pDoc)->SetDrawGeoDiv(TRUE);
	}
}

void CMainFrame::OnUpdateImageCropsetup(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		pCmdUI->Enable(((CDibDoc*) pDoc)->GetState()==CI_SHOWRAWIMAGE);
	}
	else
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnImageMeasurePrepare() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		((CDibDoc*) pDoc)->GetLeafDib();
	}
}

void CMainFrame::OnUpdateImageMeasurePrepare(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		pCmdUI->Enable(((CDibDoc*) pDoc)->GetState()==CI_SHOWRAWIMAGE);
	}
	else
		pCmdUI->Enable(FALSE);
}

void CMainFrame::OnOptionsSave() 
{
	SaveConfigFile();	
}

void CMainFrame::OnUpdateOptionsSave(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(configChanged);
}

void CMainFrame::OnImageAdjustment() 
{
	CDibView* pView = (CDibView*) GetActiveView();

	LPCTSTR lpszText = "The image adjustment was done by the manufacturer. Are you sure you want to proceed?";

	if (!pView->IsImageAdjustment())
		if (AfxMessageBox(lpszText, MB_YESNOCANCEL) != IDYES)
			return;

	CDocument* pDoc = GetActiveDocument();

	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		if (pView->IsImageAdjustment())
			pView->SetImageAdjustment(FALSE);
		else
		{
			pView->SetImageAdjustment(TRUE);
			((CDibDoc*) pDoc)->SetDrawGeoDiv(TRUE);
		}
	}
}

void CMainFrame::OnUpdateImageAdjustment(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		pCmdUI->Enable(((CDibDoc*) pDoc)->GetState()!=CI_INITIALIZED);
	}
	else
		pCmdUI->Enable(FALSE);

	CDibView* pView = (CDibView*) GetActiveView();
	if (pView->IsImageAdjustment())
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CMainFrame::OnButtonAdjustment() 
{
	OnImageAdjustment();
}

void CMainFrame::OnUpdateButtonAdjustment(CCmdUI* pCmdUI) 
{
	OnUpdateImageAdjustment(pCmdUI);
}

void CMainFrame::OnButtonMeasure() 
{
	OnImageMeasure();
}

void CMainFrame::OnUpdateButtonMeasure(CCmdUI* pCmdUI) 
{
	OnUpdateImageMeasure(pCmdUI);
}

void CMainFrame::OnImageClearall() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		((CDibDoc*) pDoc)->SetState(CI_INITIALIZED);
		((CDibDoc*) pDoc)->UpdateAllViews(NULL);
	}
}

void CMainFrame::OnUpdateImageClearall(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		if (((CDibDoc*) pDoc)->GetState() != CI_INITIALIZED)
			pCmdUI->Enable(TRUE);
		else
			pCmdUI->Enable(FALSE);
	}		
}

void CMainFrame::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		if (((CDibDoc*) pDoc)->GetState() != CI_INITIALIZED)
		{
			if (((CDibDoc*) pDoc)->saveProcessedImageWhenSave)
			{
				if (((CDibDoc*) pDoc)->GetState() != CI_SHOWLEAFIMAGE)
					pCmdUI->Enable(FALSE);
				else
					pCmdUI->Enable(TRUE);
			}
			else
				pCmdUI->Enable(TRUE);
		}
		else
			pCmdUI->Enable(FALSE);
	}	
}

void CMainFrame::OnUpdateOptionsSetup(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		if (((CDibDoc*) pDoc)->GetState() != CI_SHOWLEAFIMAGE)
			pCmdUI->Enable(TRUE);
		else
			pCmdUI->Enable(FALSE);
	}		
}

void CMainFrame::OnImageRefresh() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		((CDibDoc*) pDoc)->SetState(CI_SHOWCROPPEDIMAGE);
		((CDibDoc*) pDoc)->UpdateImages();
		((CDibDoc*) pDoc)->UpdateAllViews(NULL);
	}
}

void CMainFrame::OnUpdateImageRefresh(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		if (((CDibDoc*) pDoc)->GetState() == CI_SHOWLEAFIMAGE)
			pCmdUI->Enable(TRUE);
		else
			pCmdUI->Enable(FALSE);
	}
}

void CMainFrame::OnUpdateFileSaveprocessedimage(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();

	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		if (((CDibDoc*) pDoc)->saveProcessedImageWhenSave)
			pCmdUI->SetCheck(TRUE);
		else
			pCmdUI->SetCheck(FALSE);
	}
}

void CMainFrame::OnFileSaveprocessedimage() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc))) {
		if (((CDibDoc*) pDoc)->saveProcessedImageWhenSave)
			((CDibDoc*) pDoc)->saveProcessedImageWhenSave = FALSE;
		else
			((CDibDoc*) pDoc)->saveProcessedImageWhenSave = TRUE;
	}
}

void CMainFrame::OnViewWindowScale3quarter() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)))
	{
		((CDibDoc*) pDoc)->viewImageScale = (float)(3./4.);
		((CDibDoc*) pDoc)->UpdateAllViews(NULL);
		needResize = TRUE;
	}	
}

void CMainFrame::OnUpdateViewWindowScale3quarter(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)) && ((CDibDoc*) pDoc)->viewImageScale == (float)(3./4.))
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CMainFrame::OnViewWindowScale5sixth() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)))
	{
		((CDibDoc*) pDoc)->viewImageScale = (float)(5.0/6.0);
		((CDibDoc*) pDoc)->UpdateAllViews(NULL);
		needResize = TRUE;
	}	
}

void CMainFrame::OnUpdateViewWindowScale5sixth(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)) && ((CDibDoc*) pDoc)->viewImageScale == (float)(5.0/6.0))
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CMainFrame::OnViewWindowScale7eigth() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)))
	{
		((CDibDoc*) pDoc)->viewImageScale = (float)(7./8.);
		((CDibDoc*) pDoc)->UpdateAllViews(NULL);
		needResize = TRUE;
	}	
}

void CMainFrame::OnUpdateViewWindowScale7eigth(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)) && ((CDibDoc*) pDoc)->viewImageScale == (float)(7./8.))
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CMainFrame::OnViewWindowScaleFull() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)))
	{
		((CDibDoc*) pDoc)->viewImageScale = (float)1.0;
		((CDibDoc*) pDoc)->UpdateAllViews(NULL);
		needResize = TRUE;
	}	
}

void CMainFrame::OnViewWindowScalePlus50() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)))
	{
		((CDibDoc*) pDoc)->viewImageScale = (float)1.5;
		((CDibDoc*) pDoc)->UpdateAllViews(NULL);
		needResize = TRUE;
	}	
}

void CMainFrame::OnUpdateViewWindowScaleFull(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)) && ((CDibDoc*) pDoc)->viewImageScale == (float)1.0)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CMainFrame::OnUpdateViewWindowScalePlus50(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)) && ((CDibDoc*) pDoc)->viewImageScale == (float)1.5)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}

void CMainFrame::OnViewWindowScaleHalf() 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)))
	{
		((CDibDoc*) pDoc)->viewImageScale = (float)0.5;
		((CDibDoc*) pDoc)->UpdateAllViews(NULL);
		needResize = TRUE;
	}	
}

void CMainFrame::OnUpdateViewWindowScaleHalf(CCmdUI* pCmdUI) 
{
	CDocument* pDoc = GetActiveDocument();
	if (pDoc->IsKindOf(RUNTIME_CLASS(CDibDoc)) && ((CDibDoc*) pDoc)->viewImageScale == (float)0.5)
		pCmdUI->SetCheck(TRUE);
	else
		pCmdUI->SetCheck(FALSE);
}


void CMainFrame::OnFilePrint() 
{
	char curDir[256];
	if (GetCurrentDirectory(256, &curDir[0]) == 0)
		curDir[0] = 0;
	if (launchDirectory[0] != 0)
		SetCurrentDirectory(&launchDirectory[0]);

	//_spawnl( _P_WAIT, "Photoprn.exe", "Photoprn.exe", NULL );
	_spawnl( _P_NOWAIT, "Photoprn.exe", "Photoprn.exe", NULL );
	
	if (curDir[0] != 0)
		SetCurrentDirectory(&curDir[0]);
}
