// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////
#ifndef _CI_MAINFRM_H_
#define _CI_MAINFRM_H_

#include "global.h"
#include "CTwain.h"
#include "CiSetup.h"




//class CMainFrame : public CFrameWnd, CTwain
class CMainFrame : public CFrameWnd
{
private:
	CCiSetup setupPS;

	BOOL	configChanged;

protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes


public:

// Operations
public:
	void ReadConfigFile();
	void SaveConfigFile();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	virtual void TwainError(TW_ERR e);
	virtual void DibReceived(HGLOBAL hdib);

	BOOL	isConfigChanged() { return configChanged; }
	void	setConfigChanged(BOOL b) {configChanged = b;}
	BOOL	needResize;	//tell the view that size of mainframe has been changed.
	//which dir this program was launched.
	char	launchDirectory[256];

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdateAcquire(CCmdUI* pCmdUI);
	afx_msg void OnAcquire();
	afx_msg void OnSunflecks();
	afx_msg void OnUpdateSelectSource(CCmdUI* pCmdUI);
	afx_msg void OnSelectSource();
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnPaletteChanged(CWnd* pFocusWnd);
	afx_msg BOOL OnQueryNewPalette();
	afx_msg void OnOptionsSetup();
	afx_msg void OnAcquireClipboard();
	afx_msg void OnUpdateAcquireClipboard(CCmdUI* pCmdUI);
    afx_msg LRESULT OnUserApply(WPARAM wParam, LPARAM lParam);
	afx_msg void OnImageMeasure();
	afx_msg void OnUpdateImageMeasure(CCmdUI* pCmdUI);
	afx_msg void OnImageCropsetup();
	afx_msg void OnUpdateImageCropsetup(CCmdUI* pCmdUI);
	afx_msg void OnImageMeasurePrepare();
	afx_msg void OnUpdateImageMeasurePrepare(CCmdUI* pCmdUI);
	afx_msg void OnOptionsSave();
	afx_msg void OnUpdateOptionsSave(CCmdUI* pCmdUI);
	afx_msg void OnImageAdjustment();
	afx_msg void OnUpdateImageAdjustment(CCmdUI* pCmdUI);
	afx_msg void OnButtonAdjustment();
	afx_msg void OnUpdateButtonAdjustment(CCmdUI* pCmdUI);
	afx_msg void OnButtonMeasure();
	afx_msg void OnUpdateButtonMeasure(CCmdUI* pCmdUI);
	afx_msg void OnImageClearall();
	afx_msg void OnUpdateImageClearall(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOptionsSetup(CCmdUI* pCmdUI);
	afx_msg void OnImageRefresh();
	afx_msg void OnUpdateImageRefresh(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveprocessedimage(CCmdUI* pCmdUI);
	afx_msg void OnFileSaveprocessedimage();
	afx_msg void OnViewWindowScale3quarter();
	afx_msg void OnUpdateViewWindowScale3quarter(CCmdUI* pCmdUI);
	afx_msg void OnViewWindowScale5sixth();
	afx_msg void OnUpdateViewWindowScale5sixth(CCmdUI* pCmdUI);
	afx_msg void OnViewWindowScale7eigth();
	afx_msg void OnUpdateViewWindowScale7eigth(CCmdUI* pCmdUI);
	afx_msg void OnViewWindowScaleFull();
	afx_msg void OnUpdateViewWindowScaleFull(CCmdUI* pCmdUI);
	afx_msg void OnViewWindowScalePlus50();
	afx_msg void OnUpdateViewWindowScalePlus50(CCmdUI* pCmdUI);
	afx_msg void OnViewWindowScaleHalf();
	afx_msg void OnUpdateViewWindowScaleHalf(CCmdUI* pCmdUI);
	afx_msg void OnFilePrint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif
/////////////////////////////////////////////////////////////////////////////
